/* 
   $Id: IMDataType.c,v 1.5 2001/12/25 05:30:39 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>

#include "IMProto.h"
#include "IMlib.h"
#include "default.h"

/* IM Connection */
extern int		NumImConnection;
extern ImConnectionRec	*im_connection;


extern int	NumInputContext;
extern XIC_Rec	*InputContext;



#if 0
int	XimSetImValue( int idx, XIMATTRIBUTE *ximatr )
{
  int	dataType;

  // Data Type 
  if ( ximatr->attrID != default_ximattr.ID ){
    fprintf(stderr," Unsupoorted attribute ID\n");
    return -1;
  }
  dataType = default_ximattr.TypeOfValue;
  
  switch ( dataType ){
  case TOV_XIMStyles:{
    XIMStyles	*ximstyle = (XIMStyles *)malloc( sizeof(XIMStyles) );
    int		j, k, num;

    im_connection[idx].ximatr[0].attrID = ximatr->attrID;
    im_connection[idx].ximatr[0].len    = ximatr->len;
    //    im_connection[idx].ximatr[0].ptr    = (unsigned char *)ximstyle;
    k = 0;
    num = ximstyle->count_styles = XimPcktGetCARD16( &(ximatr->ptr[k]) );k+=2;
    k += 2;
    ximstyle->supported_styles = (unsigned long *)malloc( sizeof(long)*num );
    for( j=0; j<num; j++ ){
      ximstyle->supported_styles[j] = XimPcktGetCARD32( &(ximatr->ptr[k]) );
      k += 4;
    }
  }
  default:
    fprintf(stderr," Unsupported DataType %d\n", dataType );
  }
  return 0;
}
#endif

int	XimPcktGetXIMATTRIBUTE( unsigned char *pckt, 
				XIMATTRIBUTE *ximattribute )
{
  int		i, pad_len, attrID;

  i = 0;
  attrID = ximattribute->attrID = XimPcktGetCARD16( pckt ); i+=2;
  ximattribute->len    = XimPcktGetCARD16( &(pckt[i]) );
  ximattribute->ptr    = &(pckt[4]); i+=ximattribute->len;
  pad_len = PADDING( ximattribute->len );
  return i + pad_len;
}


int	XimPcktSetXIMATTRIBUTE( unsigned char *pckt,
				int attrID )
{
  int		i, dataType, p;

  // Data Type 
  if ( attrID != default_ximattr.ID ){
    fprintf(stderr," Unsupoorted attribute ID\n");
    return -XIMERR_BADSOMETHING;
  }
  dataType = default_ximattr.TypeOfValue;

  i = 0;
  i += XimPcktSetCARD16( pckt, attrID );
  p = i; i += 2;	// reserved
  switch ( dataType ){
  case TOV_XIMStyles:
    {
      XIMStyles	*ximstyle = &defaultInputStyles;
      int	j;
      
      i += XimPcktSetCARD16( &(pckt[i]), ximstyle->count_styles );
      i += 2; //unused
      for( j=0; j<ximstyle->count_styles; j++ ){
	i+= XimPcktSetCARD32( &(pckt[i]), ximstyle->supported_styles[j] );
      }
      XimPcktSetCARD16( &(pckt[p]), i-p-2 );
      i += PADDING(i-p-2);
      break;
    }
  default:
    fprintf(stderr," Unsupported DataType %d\n", dataType );
  }
  return i;
}




int	XimPcktSetXICATTRIBUTE( unsigned char *pckt,
				XICATTRIBUTE *xicattribute )
{
  int	i, pad_len;
  
  i = 0;
  i += XimPcktSetCARD16( pckt, xicattribute->attrID );
  i += XimPcktSetCARD16( &(pckt[i]), xicattribute->len );
  memcpy( &(pckt[i]), xicattribute->ptr, xicattribute->len );
  i += xicattribute->len;
  pad_len = PADDING( xicattribute->len );
  memset( &(pckt[i]), 0, xicattribute->len );
  i += pad_len;
  
  return i;
}



int	XimSetXICATTRIBUTE( int icID,
			    XICATTRIBUTE *xicatr )
{
  int		idx, i, len;
  XIC_Rec	*icptr;
  void		*newptr;

  if ((i = XimGetICidx(icID)) < 0) {
    fprintf(stderr," IC is not found\n");
    return -1;
  }
  icptr = &(InputContext[i]);
  for( i=0; i<XtNumber(default_xicattr); i++ ){
    if ( icptr->xicattr[i].ID == xicatr->attrID ) break;
  }
  if ( i< XtNumber(default_xicattr) ){
    idx = i;
  }else{
    fprintf(stderr," ICATTR is not found\n");
    return -1;
  }
  len = xicatr->len;
  if (len < 0) len = 0;
  if (icptr->xicattr[idx].ptr != NULL) {
      newptr = (void *)realloc( (void *)icptr->xicattr[idx].ptr, len );
  } else {
      newptr = (void *)malloc(len);
  }
  icptr->xicattr[idx].ptr = (unsigned char *)newptr;
  memcpy( newptr, xicatr->ptr, len );
  icptr->xicattr[idx].len = len;
  return 0;
}


int	XimGetXICATTRIBUTE( int icID, int atrID, 
			    XICATTRIBUTE *xicatr )
{
  int		idx, i;
  XIC_Rec	*icptr;

  if ((i = XimGetICidx(icID)) < 0) {
    fprintf(stderr," IC is not found\n");
    return -1;
  }
  icptr = &(InputContext[i]);
  for( i=0; i<XtNumber(default_xicattr); i++ ){
    if ( icptr->xicattr[i].ID == atrID ) break;
  }
  if ( i< XtNumber(default_xicattr) ){
    idx = i;
  }else{
    fprintf(stderr," ICATTR is not found\n");
    return -XIMERR_BADSOMETHING;
  }
  xicatr->attrID = icptr->xicattr[idx].ID;
  xicatr->len    = icptr->xicattr[idx].len;
  xicatr->ptr    = icptr->xicattr[idx].ptr;

  return 0;
}



int	XimConvertToCompoundText( Display *dpy,
				  XICCEncodingStyle style,
				  char	*str, XTextProperty *ct )
{
  char	*cl[1];

  cl[0] = str;
  XmbTextListToTextProperty( dpy, cl, 1, XCompoundTextStyle, ct );
  return 0;
}    



int	XimConvertXEventToxEvent( XEvent *ev, xEvent *sEv )
{
  sEv->u.u.type                  = ev->type;
  sEv->u.u.sequenceNumber        = ev->xany.serial & 0xffff;
  sEv->u.u.type                 |= ( ev->xany.send_event )? 0x80:0;
  sEv->u.keyButtonPointer.event  = ev->xkey.window;
  sEv->u.keyButtonPointer.root   = ev->xkey.root;
  sEv->u.keyButtonPointer.child  = ev->xkey.subwindow;
  sEv->u.keyButtonPointer.time   = ev->xkey.time;
  sEv->u.keyButtonPointer.eventX = ev->xkey.x;
  sEv->u.keyButtonPointer.eventY = ev->xkey.y;
  sEv->u.keyButtonPointer.rootX  = ev->xkey.x_root;
  sEv->u.keyButtonPointer.rootY  = ev->xkey.y_root;
  sEv->u.keyButtonPointer.state  = ev->xkey.state;
  sEv->u.u.detail                = ev->xkey.keycode;
  sEv->u.keyButtonPointer.sameScreen  = ev->xkey.same_screen;
  return 0;
}


