/* 
   $Id: IMProto.c,v 1.5 2001/12/25 05:30:39 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>

#include "IMProto.h"
#include "IMlib.h"

/* IM Connection */
extern int		NumImConnection;
extern ImConnectionRec	*im_connection;

extern	Atom	cmAtom_XIM_PROTOCOL;
extern	Atom	cmAtom_XIM_MOREDATA;
extern	Atom	cmAtom_NUNOME_COMM;

/*
 *
 */
int	SendXIMPacket( Display *dpy, Window sender, 
		       Window serv_w, unsigned char *pckt, int len )
{
  unsigned char		*xim_packet = pckt;
  XClientMessageEvent	sendev;
  
  memset( &sendev, 0, sizeof(XClientMessageEvent) );
  XSync(dpy,False);
  IMHookXError();
  if ( len > 20 ){	//  via Property with ClientMessageEvent
    XChangeProperty( dpy, sender, cmAtom_NUNOME_COMM, XA_STRING,
		     8, PropModeAppend, xim_packet, len );
    // ClientMessageEvent
    sendev.type    = ClientMessage;
    sendev.display = dpy;
    sendev.window  = (Window)sender;
    sendev.message_type = cmAtom_XIM_PROTOCOL;
    sendev.format  = 32;
    sendev.data.l[0] = len;
    sendev.data.l[1] = cmAtom_NUNOME_COMM;
    XSendEvent( dpy, sender, False, NoEventMask,
		(XEvent *)&sendev );
  }else{		//  via ClientMessageEvent Only
    sendev.type    = ClientMessage;
    sendev.display = dpy;
    sendev.window  = (Window)sender;
    sendev.message_type = cmAtom_XIM_PROTOCOL;
    sendev.format  = 8;
    memcpy( sendev.data.b, xim_packet, len );
    XSendEvent( dpy, sender, False, NoEventMask,
		(XEvent *)&sendev );
  }
  XSync(dpy,False);
  if (IMUnhookXError() > 0) {
    DisposeIMConnection(sender);
  }
  return 0;
}



#if 0
/*
 *	display dump of IM Protocol Packet
 */
static	void	printClientMessage( XClientMessageEvent	*ev )
{
  int	i;
  int	major_opcode, minor_opcode;
  int	length;
  
  fprintf(stderr,"type %3d: message_type %3lu : format %3d\n",
	 ev->type, ev->message_type, ev->format );
  major_opcode = (unsigned char)ev->data.b[0];
  minor_opcode = (unsigned char)ev->data.b[1];
  length       = (unsigned short)ev->data.s[1];
  fprintf(stderr,"  IM Protocol: opcode (%3d:%3d), length= %2d\n",
	 major_opcode, minor_opcode, length );
  for( i=0; i<length*4; i++ ){
    fprintf(stderr,"%02x, ", ev->data.b[i+4]);
  }
  fprintf(stderr,"\n");
}
#endif



/*
 *	Recieve a XIM Protocol and dispatch the packet
 *	( via Property with ClientMessage Event )
 */
static void	XIMdispatchPacket( Widget w, Window sender, int major_opcode, 
				   int minor_opcode, int len, 
				   unsigned char *packet )
{
#ifdef DEBUG_PRINT
  fprintf(stderr,"major %04d\n", major_opcode );
#endif
  switch ( major_opcode ){
  case XIM_CONNECT:
    RecieveXIM_CONNECT( packet, len, sender, w );
    break;
  case XIM_DISCONNECT:
    RecieveXIM_DISCONNECT( packet, len, sender, w );
    break;
  case XIM_CONNECT_REPLY:
  case XIM_DISCONNECT_REPLY:
  case XIM_AUTH_REQUIRED:
  case XIM_AUTH_REPLY:
  case XIM_AUTH_NEXT:
  case XIM_AUTH_SETUP:
  case XIM_AUTH_NG:
    fprintf(stderr," Not Supported Opcode(major:minor) %3d:%3d\n",
	   major_opcode, minor_opcode );
    break;
  case XIM_ERROR:
    fprintf(stderr," XIM_Error\t");
    {
	int i;

	for( i=0; i<len*4; i++ ){
	  fprintf(stderr,"%02X ", packet[i] );
	}
	fprintf(stderr,"\n");
    }
    break;
  case XIM_OPEN:
    RecieveXIM_OPEN( packet, len, sender, w );
    break;
  case XIM_CLOSE:
    RecieveXIM_CLOSE( packet, len, sender, w );
    break;
  case XIM_QUERY_EXTENSION:
    RecieveXIM_QUERY_EXTENSION( packet, len, sender, w );
    break;
  case XIM_ENCODING_NEGOTIATION:
    RecieveXIM_ENCODING_NEGOTIATION( packet, len, sender, w );
    break;
  case XIM_SET_IM_VALUES:
    RecieveXIM_SET_IM_VALUES( packet, len, sender, w );
    break;
  case XIM_GET_IM_VALUES:
    RecieveXIM_GET_IM_VALUES( packet, len, sender, w );
    break;

  case XIM_TRIGGER_NOTIFY:
    RecieveXIM_TRIGGER_NOTIFY( packet, len, sender, w );
    break;
  case XIM_CREATE_IC:
    RecieveXIM_CREATE_IC( packet, len, sender, w );
    break;
  case XIM_DESTROY_IC:
    RecieveXIM_DESTROY_IC( packet, len, sender, w );
    break;
  case XIM_SET_IC_VALUES:
    RecieveXIM_SET_IC_VALUES( packet, len, sender, w );
    break;
  case XIM_GET_IC_VALUES:
    RecieveXIM_GET_IC_VALUES( packet, len, sender, w );
    break;
  case XIM_SET_IC_FOCUS:
    RecieveXIM_SET_IC_FOCUS( packet, len, sender, w );
    break;
  case XIM_UNSET_IC_FOCUS:
    RecieveXIM_UNSET_IC_FOCUS( packet, len, sender, w );
    break;

  case XIM_FORWARD_EVENT:
    RecieveXIM_FORWARD_EVENT( packet, len, sender, w );
    break;
  case XIM_SYNC:
    RecieveXIM_SYNC( packet, len, sender, w );
    break;
  case XIM_SYNC_REPLY:
#ifdef DEBUG_PRINT
    fprintf(stderr," NoDone: Recieve XIM_SYNC_REPLY\n");
#endif
    SendXIM_ERROR(sender,w,0,0,0,XIMERR_BADPROTOCOL);
    break;


  default:
    fprintf(stderr," Not Support Opcode: %d %d\n", major_opcode, minor_opcode );
  }
}

/*
 *	Recieve a XIM Protocol and dispatch the packet
 *	( via ClientMessage Event Only )
 */
static void	XIM_RecieveClientMessage( Widget w, XClientMessageEvent *ev )
{
  int		major_opcode, minor_opcode;
  int		length, i;
  Window	sender_w;
  unsigned char	*packet;

  if (ev->message_type != cmAtom_XIM_PROTOCOL) {
    if (ev->message_type == cmAtom_XIM_MOREDATA) {
	fprintf(stderr,"XIM_MOREDATA is not supported\n");
    } else {
	fprintf(stderr,"Unknown messsage type in ClientMessage to the Communication Window\n");
    }
    return;
  }
  for( i=0; i<NumImConnection; i++ ){
    if ( w == im_connection[i].server ) break;
  }
  if ( i<NumImConnection ){
    sender_w = im_connection[i].client;
  }else{
    sender_w = 0;
  }

  major_opcode = (unsigned char)ev->data.b[0];
  minor_opcode = (unsigned char)ev->data.b[1];
  length       = (unsigned short)ev->data.s[1];
  packet       = (unsigned char *)&(ev->data.b[4]);
  
  XIMdispatchPacket( w, sender_w, major_opcode, minor_opcode, 
		     length, packet );
}


/*
 *	Recieve a XIM Protocol and dispatch the packet
 *	( via Property with ClientMessage Event )
 */
static void	XIM_RecievePropertyWithCM( Widget w, XClientMessageEvent *ev )
{
  int		major_opcode, minor_opcode;
  int		length, i, act_form, l, n;
  unsigned long	nitems, ba;
  unsigned char	*packet, *prop_ret;
  Atom		propAtom, act_type;
  Window	sender_w;
  
  for( i=0; i<NumImConnection; i++ ){
    if ( w == im_connection[i].server ) break;
  }
  if ( i<NumImConnection ){
    sender_w = im_connection[i].client;
  }else{
    sender_w = 0;
  }
  propAtom = (Atom)ev->data.l[1];
  XGetWindowProperty( XtDisplay(w), XtWindow(w), propAtom, 0L,
		      100000L, True, XA_STRING, &act_type,
		      &act_form, &nitems, &ba, &prop_ret );
  if ( act_form == 0 ){
    /* Cannot find Property */
    fprintf(stderr,"Cannot find property [window:%lu]\n", sender_w);
  }else if ( nitems==0 ){
    /* Unmatch Property Type */
    fprintf(stderr,"Unmatch property type\n");
  }else{
    for( n=l=0; l<nitems; n++ ){
      major_opcode = prop_ret[l]; l++;
      minor_opcode = prop_ret[l]; l++;
      length       = prop_ret[l] | ( prop_ret[l+1]<<8 ); l+=2;
      packet       = &(prop_ret[l]);

      XIMdispatchPacket( w, sender_w, major_opcode, minor_opcode,
			 length, packet );
      l += length*4;
    }
    XFree( prop_ret );
  }
}


void	CommWidgetEvHandler( Widget w, XtPointer clo, 
			     XEvent *ev, Boolean *ctd )
{
  int		i;
  XClientMessageEvent	*cm_ev = (XClientMessageEvent *)ev;
  
  for( i=0; i<NumImConnection; i++ ){
    if ( w == im_connection[i].server ) break;
  }
#ifdef DEBUG_PRINT
  if ( i<NumImConnection ){
    fprintf(stderr,"Client %d --> Server %d: ",
	   im_connection[i].client,
	   XtWindow( w ) );
  }
#endif

  switch( ev->type ){
  case PropertyNotify:
    fprintf(stderr,"CommWidgetEvHandler: PropertyNotify Event is not supported\n");
    break;
  case SelectionRequest:
    fprintf(stderr,"CommWidgetEvHandler: SelectionRequest Event is not supported\n"); 
    break;
  case ClientMessage:
    if ( cm_ev->format == 8 ){	/* XIM Protocol via Client Message Only */
      XIM_RecieveClientMessage( w, cm_ev );
    }else if( cm_ev->format == 32 ){
      /* XIM Protocol via Property with Client Message */
      XIM_RecievePropertyWithCM( w, cm_ev );
    }else{
      fprintf(stderr,"  Client Message Format is wrong! \n");
    }
    break;
  default:
    fprintf(stderr,"CommWidgetEvHandler: Event %d is not supported\n", ev->type );
    break;
  }
  
}
