/* 
   $Id: PcktCreate.c,v 1.6 2001/12/25 05:30:39 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>

#include "IMProto.h"
#include "IMlib.h"
#include "default.h"

/* IM Connection */
extern int		NumImConnection;
extern ImConnectionRec	*im_connection;

extern int	NumInputContext;
extern XIC_Rec	*InputContext;

int	XimGetICidx( int icID )
{
  if (icID < 0 || icID >= NumInputContext) return -1;
  if (InputContext[icID].use != 0) return icID;
  return -1;
}

int	XimGetIMidx( int imID )
{
  if (imID < 0 || imID >= NumImConnection) return -1;
  if (im_connection[imID].use != 0) return imID;
  return -1;
}

int	XimCreateIC( int imID)
{
  XIC_Rec	*newptr;
  int		i;
  int icID;
  
  for( i=0; i<NumInputContext; i++ ){
    if ( InputContext[i].use == 0 ) break;
  }
  if ( i<NumInputContext ){
    newptr = &(InputContext[i]);
    icID = i;
  }else{
    NumInputContext++;
    if (InputContext != NULL) {
	InputContext = (XIC_Rec *)realloc( (void *)InputContext,
				     NumInputContext*sizeof(XIC_Rec) );
    } else {
	InputContext = (XIC_Rec *)malloc(NumInputContext*sizeof(XIC_Rec) );
    }
    newptr = &(InputContext[NumInputContext-1]);
    icID = NumInputContext-1;
  }
  //
  newptr->use = 1;
  newptr->imID = imID;
  for( i=0; i<XtNumber(default_xicattr); i++ ){
    newptr->xicattr[i].ID = default_xicattr[i].ID;
    newptr->xicattr[i].len    = 0;
    newptr->xicattr[i].ptr    = NULL;
  }
  // Default Setting
  newptr->xicattr[0].len = 4;
  newptr->xicattr[0].ptr = (unsigned char *)malloc( 4 );
  memcpy( newptr->xicattr[0].ptr, &defaultInputStyle, 4 );

  newptr->xicattr[3].len = 4;
  newptr->xicattr[3].ptr = (unsigned char *)malloc( 4 );
  memcpy( newptr->xicattr[3].ptr, &defaultFilterEvents, 4 );

  return icID;
}

static void XimDoDestroyIC(int icidx)
{
  int j;

  InputContext[icidx].use  = 0;
  for( j=0; j<XtNumber(default_xicattr); j++ ){
    if ( InputContext[icidx].xicattr[j].ptr != NULL ){
      free( InputContext[icidx].xicattr[j].ptr );
      InputContext[icidx].xicattr[j].ptr = NULL;
    }
  }
  if (icidx == NumInputContext - 1) {
    for (j = NumInputContext-2;j >= 0;j--) {
	if (InputContext[j].use != 0) break;
    }
    NumInputContext = j+1;
    if (NumInputContext == 0) {
	free(InputContext);
	InputContext = NULL;
    } else {
	InputContext = (XIC_Rec *)realloc( (void *)InputContext,
			     NumInputContext*sizeof(XIC_Rec) );
    }
  }
}

int	XimDestroyIC( int imID, int icID )
{
  int		i;

  if ((i = XimGetICidx(icID)) < 0) return -1;
  if (InputContext[i].imID != imID) return -1;
  XimDoDestroyIC(i);
  return 0;
}

void	XimDestroyAllIC(int imID)
{
    int i;

    for (i = 0;i < NumInputContext;i++) {
	if (InputContext[i].use != 0 && InputContext[i].imID == imID) {
	    XimDoDestroyIC(i);
	}
    }
}

/*
 *
 */
int	CreatePacketXIM_OPEN_REPLY( unsigned char *buf, Window sender )
{
  int	i, j, len, p, n;
  
  for( n=0; n<NumImConnection; n++ ){
    if ( im_connection[n].client == sender ) break;
  }
  if ( n>=NumImConnection ){
    fprintf(stderr," Connection Error\n");
    return -XIMERR_BADCLIENTWINDOW;
  }
  i = 0;
  buf[i] = XIM_OPEN_REPLY; i++;
  buf[i] = 0; i++;
  i += 2;
  i += XimPcktSetCARD16( &(buf[i]), n);
  len = XimPcktSetXIMATTR( &(buf[i+2]), &default_ximattr );
  i += XimPcktSetCARD16( &(buf[i]), len );
  i += len; p = i; i+= 4;
  
  for( len=j=0; j<XtNumber(default_xicattr); j++ ){
    len = XimPcktSetXICATTR( &(buf[i]), &(default_xicattr[j]) );
    i += len;
  }
  XimPcktSetCARD16( &(buf[p]), i-p-4 );
  XimPcktSetCARD16( &(buf[2]), (i-4)/4 );
  return i;
}

     
int	CreatePacketXIM_REGISTER_TRIGGERKEYS( unsigned char *buf, 
					      Window sender )
{
  int	i, n;

  for( n=0; n<NumImConnection; n++ ){
    if ( im_connection[n].client == sender ) break;
  }
  if ( n>=NumImConnection ){
    fprintf(stderr," Connection Error\n");
    return -XIMERR_BADCLIENTWINDOW;
  }
  i = 0;
  buf[i] = XIM_REGISTER_TRIGGERKEYS; i++;	// major opcode
  buf[i] = 0; i++;				// minor opcode
  i += 2;  					// length (last set)
  i += XimPcktSetCARD16( &(buf[i]), n );
  i += 2; //  unused
  // on-key list
  i += XimPcktSetCARD32( &(buf[i]), 0 );

  // off-key list
  i += XimPcktSetCARD32( &(buf[i]), 0 );
  XimPcktSetCARD32( &(buf[2]), (i-4)/4 );
  return i;
}

int	CreatePacketXIM_QUERY_EXTENSION_REPLY( unsigned char *buf, 
					       Window sender, int imID )
{
  int		i;

  i = 0;
  buf[i] = XIM_QUERY_EXTENSION_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;				// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );
  i += XimPcktSetCARD16( &(buf[i]), imID );
  i += XimPcktSetCARD16( &(buf[i]), 0 );
  return i;
}
  


int	CreatePacketXIM_ENCODING_NEGOTIATION_REPLY( unsigned char *buf, 
						    Window sender,
						    int imID, int idx )
{
  int		i;

  i = 0;
  buf[i] = XIM_ENCODING_NEGOTIATION_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;				// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 2 );	// packet length

  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), 0 );	// category is name
  i += XimPcktSetCARD16( &(buf[i]), idx );
  buf[i] = buf[i+1] = 0; i+=2;			// unused
  return i;
}
  

int	CreatePacketXIM_CLOSE_REPLY( unsigned char *buf, Window sender, 
				     int imID )
{
  int		i;

  i = 0;
  buf[i] = XIM_CLOSE_REPLY; i++;		// major-opcode
  buf[i] = 0; i++;				// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );	// packet length

  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), 0 );	// category is name
  return i;
}
  


int	CreatePacketXIM_SET_IM_VALUES_REPLY( unsigned char *buf,
					     Window sender,
					     int imID )
{
  int		i;

  i = 0;
  buf[i] = XIM_SET_IM_VALUES_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;				// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );	// packet length

  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  buf[i] = buf[i+1] = 0; i+=2;
  return i;
}
  


int	CreatePacketXIM_GET_IM_VALUES_REPLY( unsigned char *buf, Window sender,
					     int idx, int *attrID, int attrlen )
{
  int		i, p, p2;
  int r;

  i = 0;
  buf[i] = XIM_GET_IM_VALUES_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;				// minor-opcode
  p = i; i += 2;				// packet length (reserved)
  i += XimPcktSetCARD16( &(buf[i]), idx );// input-method ID
  p2 = i; i+=2;
  if ( attrlen != 1 ){
    fprintf(stderr," XIM_GET_IM_VALUES_REPLY: attribute num = %d\n", attrlen );
  }
  if ((r = XimPcktSetXIMATTRIBUTE( &(buf[i]), attrID[0])) < 0) {
    return r;
  }
  i += r;
  XimPcktSetCARD16( &(buf[p2]), i-p2-2 );
  XimPcktSetCARD16( &(buf[p]), (i-p-2)/4 );
  return i;
}




int	CreatePacketXIM_CREATE_IC_REPLY( unsigned char *buf, Window sender,
					 int imID, int icID )
{
  int		i;

  i = 0;
  buf[i] = XIM_CREATE_IC_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;			// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );	// length
  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), icID );	// input-context ID
  return i;
}


int	CreatePacketXIM_DESTROY_IC_REPLY( unsigned char *buf, Window sender,
					  int imID, int icID )
{
  int		i;

  i = 0;
  buf[i] = XIM_DESTROY_IC_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;			// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );	// length
  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), icID );	// input-context ID
  return i;
}



int	CreatePacketXIM_SET_IC_VALUES_REPLY( unsigned char *buf, Window sender,
					     int imID, int icID )
{
  int		i;

  i = 0;
  buf[i] = XIM_SET_IC_VALUES_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;				// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );	// length
  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), icID );	// input-context ID
  return i;
}



int	CreatePacketXIM_GET_IC_VALUES_REPLY( unsigned char *buf, Window sender,
					     int imID, int icID,
					     int *xicattrID, 
					     int num_xicattr )
{
  int		i, p, p2;
  int		n;
  XICATTRIBUTE	xicatr;
  int r;


  i = 0;
  buf[i] = XIM_GET_IC_VALUES_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;				// minor-opcode
  p = i; i+=2;
  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), icID );	// input-context ID
  p2 = i; i += 2;
  i += XimPcktSetCARD16( &(buf[i]), 0 );			// unused
  for( n=0; n<num_xicattr; n++ ){
    if ((r = XimGetXICATTRIBUTE( icID, xicattrID[n], &xicatr )) < 0) {
	return r;
    }
    i += XimPcktSetXICATTRIBUTE( &(buf[i]), &xicatr );
  }
  XimPcktSetCARD16( &(buf[p2]), (i-p2-4) );
  XimPcktSetCARD16( &(buf[p]), (i-p-2)/4 );
  return i;
}




int	CreatePacketXIM_TRIGGER_NOTIFY_REPLY( unsigned char *buf,
					      Window sender, 
					      int imID, int icID )
{
  int		i;

  i = 0;
  buf[i] = XIM_TRIGGER_NOTIFY_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;			// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );	// length
  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), icID );	// input-context ID
  return i;
}


int	CreatePacketXIM_SET_EVENT_MASK( unsigned char *buf, Window sender,
					int imID, int icID,
					unsigned long fevmask,
					unsigned long sevmask )
{
  int		i;

  i = 0;
  buf[i] = XIM_SET_EVENT_MASK; i++;	// major-opcode
  buf[i] = 0; i++;			// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 3 );	// length
  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), icID );	// input-context ID
  i += XimPcktSetCARD32( &(buf[i]), fevmask );	// forward-event-mask
  i += XimPcktSetCARD32( &(buf[i]), sevmask );	// synchronous-event-mask
  return i;
}


int	CreatePacketXIM_SYNC_REPLY( unsigned char *buf, Window sender,
				    int	imID, int icID )
{
  int		i;

  i = 0;
  buf[i] = XIM_SYNC_REPLY; i++;	// major-opcode
  buf[i] = 0; i++;		// minor-opcode
  i += XimPcktSetCARD16( &(buf[i]), 1 );	// length
  i += XimPcktSetCARD16( &(buf[i]), imID );	// input-method ID
  i += XimPcktSetCARD16( &(buf[i]), icID );	// input-context ID
  return i;
}


/*
int	CreatePacketXIM_FORWARD_EVENT( buf, sender, imID, icID,
				       flag, serial, evbuf, evbuflen )
     unsigned char	*buf;
     Window		sender;
     int		imID, icID, serial;
     unsigned long	flag;
     unsigned char	*evbuf;
     int		evbuflen;
{
  int		i, p, p2, n;
  
  i = 0;
  buf[i] = XIM_FORWARD_EVENT; i++;	// major_opcode
  buf[i] = 0; i++;			// minor_opcode
  i += XimPcktSetCARD16( &(buf[i]), (evbuflen+8)/4 );
  i += XimPcktSetCARD16( &(buf[i]), imID );
  i += XimPcktSetCARD16( &(buf[i]), icID );
  i += XimPcktSetCARD16( &(buf[i]), flag );
  i += XimPcktSetCARD16( &(buf[i]), serial );
  memcpy( &(buf[i]), evbuf, evbuflen ); i += evbuflen;

  return i;
}
*/

int	CreatePacketXIM_FORWARD_EVENT( unsigned char *buf, Window sender,
				       int imID, int icID, unsigned long flag,
				       int serial, XEvent *ev )
{
  int		i;
  xEvent	sEv;

  //  serial = ( ev->xany.serial >> 16 )&0xffff;
  i = 0;
  buf[i] = XIM_FORWARD_EVENT; i++;	// major_opcode
  buf[i] = 0; i++;			// minor_opcode
  i += XimPcktSetCARD16( &(buf[i]), (32+8)/4 );
  i += XimPcktSetCARD16( &(buf[i]), imID );
  i += XimPcktSetCARD16( &(buf[i]), icID );
  i += XimPcktSetCARD16( &(buf[i]), flag );
  i += XimPcktSetCARD16( &(buf[i]), serial );
  XimConvertXEventToxEvent( ev, &sEv );
  memcpy( &(buf[i]), &sEv, 32 ); i += 32;

  return i;
}



int	CreatePacketXIM_COMMIT( unsigned char *buf, Window sender,
				int imID, int icID, unsigned long flag,
				unsigned char *commit_str, int len )
{
  int		i, p, pad_len;
  
  i = 0;
  buf[i] = XIM_COMMIT; i++;	// major_opcode
  buf[i] = 0; i++;		// minor_opcode
  p = i; i += 2;		// length
  i += XimPcktSetCARD16( &(buf[i]), imID );
  i += XimPcktSetCARD16( &(buf[i]), icID );
  i += XimPcktSetCARD16( &(buf[i]), flag );
  i += XimPcktSetCARD16( &(buf[i]), len );  
  memcpy( &(buf[i]), commit_str, len ); i += len;
  pad_len = PADDING( len );
  memset( &(buf[i]), 0, pad_len ); i += pad_len;
  XimPcktSetCARD16( &(buf[p]), (i-p-2)/4 );
  return i;
}



int	CreatePacketXIM_ERROR( unsigned char *buf, Window sender,
			       int imID, int icID, int mask, int ecode )
{
  int		i;
  
  i = 0;
  buf[i] = XIM_ERROR; i++;	// major_opcode
  buf[i] = 0; i++;		// minor_opcode
  i += XimPcktSetCARD16( &(buf[i]), imID );
  i += XimPcktSetCARD16( &(buf[i]), icID );
  i += XimPcktSetCARD16( &(buf[i]), mask );
  i += XimPcktSetCARD16( &(buf[i]), ecode);  
  i += XimPcktSetCARD16( &(buf[i]), 0);
  i += XimPcktSetCARD16( &(buf[i]), 0);
  return i;
}
