/* 
   $Id: Preconnect.c,v 1.7 2001/12/25 05:30:40 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifdef HAVE_CONFIG_H
#include "../config.h"
#endif
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>

#include "IMProto.h"
#include "IMlib.h"
#include "nnmUI.h"

/* these three Atom Names is Reserved on XIM Protocol */
#define ATOM_XIM_SERVERS	"XIM_SERVERS"
#define ATOM_LOCALES		"LOCALES"
#define ATOM_TRANSPORT		"TRANSPORT"

#define ATOM_XIM_SERVER_NUNOME	"@server=_NUNOME"
#define ATOM_XIM_LOCALE_NUNOME	"@locale="
#define ATOM_XIM_TRANSPORT_NUNOME	"@transport=X/"
Atom	atom_xim_servers, atom_locales, atom_transport;
Atom	atom_server_nunome, atom_locale_nunome;
Atom	atom_transport_nunome;

#define	ATOM_XIM_PROTOCOL	"_XIM_PROTOCOL"
#define	ATOM_XIM_XCONNECT	"_XIM_XCONNECT"
#define	ATOM_XIM_MOREDATA	"_XIM_MOREDATA"
#define	ATOM_NUNOME_POPUP	"NUNOME_POPUP"
#define	ATOM_AXE_SG_NUNOME	"_AXE_SG_NUNOME"
Atom	cmAtom_XIM_PROTOCOL, cmAtom_XIM_XCONNECT;
Atom	cmAtom_XIM_MOREDATA;
Atom	cmAtom_NUNOME_POPUP;
Atom	cmAtom_AXE_SG_NUNOME;
#define ATOM_XIM_COMPROPERTY	"_NUNOME_COMM"
Atom	cmAtom_NUNOME_COMM;



/* IM Connection */
int		NumImConnection=0;
ImConnectionRec	*im_connection=NULL;

static int xerror = 0;
static XErrorHandler oldHandler;

static int hookingHandler(Display *dpy, XErrorEvent *eev)
{

  char	string[2048];

  XGetErrorText( dpy, eev->error_code, string, 2048 );
  fprintf(stderr,"ErroMsg: %s\n", string );
  fprintf(stderr," ErrorCode %d: Request %d: Minor %d\n",
	 eev->error_code, eev->request_code, eev->minor_code );
  xerror++;
  return 0;
}

void IMHookXError(void)
{
    xerror = 0;
    oldHandler = XSetErrorHandler(hookingHandler);
}

int IMUnhookXError(void)
{
    XSetErrorHandler(oldHandler);
    return xerror;
}

static XtEventDispatchProc oldDestroyDispatcher = NULL;
static XtEventDispatchProc oldReparentDispatcher = NULL;

static Boolean dispatchDestroyHook(XEvent *ev)
{
    DisposeIMConnection(ev->xdestroywindow.window);
    if (oldDestroyDispatcher != NULL) {
	return oldDestroyDispatcher(ev);
    }
    return False;
}

static Boolean dispatchReparentHook(XEvent *ev)
{
    int idx;
    Window win = ev->xreparent.window;
    Display *dpy = ev->xreparent.display;

    for (idx = 0;idx < NumImConnection;idx++) {
	if (im_connection[idx].client == win) {
	    XSync(dpy,False);
	    IMHookXError();
	    XSelectInput(dpy,ev->xreparent.parent,SubstructureNotifyMask);
	    if (IMUnhookXError() > 0) {
		DisposeIMConnection(win);
	    }
	    break;
	}
    }

    if (oldReparentDispatcher != NULL) {
	return oldReparentDispatcher(ev);
    }
    return False;
}

/*	Root Window 
 *	    "@server=_NUNOME"ȤAtom
 *	    "XIM_SERVERS"Ȥץѥƥ˾嵭Atomɲä롣	
 */
int	SetServerProperty( Widget w )
{
  Display	*dpy = XtDisplay(w);
  Window	root_win;
  Window	win = XtWindow(w);
  Atom		act_type;
  Atom		*atom_lst;
  unsigned long	nitem, byte_after;
  int		act_form, i, exist_atom, res;
  unsigned char	*prop_ret;

  //  XGrabServer(dpy);	// ŵưɻߤΤˤServerͭ٤??
  root_win = DefaultRootWindow( dpy );
  /* @server=_NUNOMEȤAtomκŵưɻ */
  atom_server_nunome = XInternAtom( dpy, ATOM_XIM_SERVER_NUNOME, False );
  if ( XGetSelectionOwner( dpy, atom_server_nunome )!=(Window)None ){
    // ˤ̤Τ᤬ưƤ
    // XUnGrabServer( dpy );
    fprintf( stderr, "NuNoMe is already exist. This process is exit.\n");
    return -1;
  }
  /* XIM_SERVERS  @server=_NUNOME ɲ */
  exist_atom = 0;
  atom_xim_servers = XInternAtom( dpy, ATOM_XIM_SERVERS, False );
  XGetWindowProperty( dpy, root_win, atom_xim_servers, 0L, 1000000L,
		      False, XA_ATOM, &act_type, &act_form,
		      &nitem, &byte_after, &prop_ret );
  atom_lst = (Atom *)prop_ret;
  for( i=0; i<nitem; i++ ){
    if ( atom_server_nunome == atom_lst[i] ){
      exist_atom = 1;
      break;
    }
  }
  if ( !exist_atom ){
    /* PropModeAppendɲ */
    res = XChangeProperty( dpy, root_win, atom_xim_servers, XA_ATOM,
			   32, PropModeAppend, 
			   (unsigned char *)&atom_server_nunome, 1);
  }else{
    res = XChangeProperty( dpy, root_win, atom_xim_servers, XA_ATOM,
			   32, PropModeReplace, 
			   (unsigned char *)prop_ret, nitem);
  }
  XFree( prop_ret );
  
  /* XIM_TRANSPORT: @transport=X/ */
  atom_transport   = XInternAtom( dpy, ATOM_TRANSPORT  , False );
  atom_transport_nunome = XInternAtom( dpy, ATOM_XIM_TRANSPORT_NUNOME, False );
  
  /* XIM_LOCALES: @locale=ja */
  atom_locales     = XInternAtom( dpy, ATOM_LOCALES    , False );
  res = XSetSelectionOwner(dpy, atom_server_nunome, win, 0L);

  // Atom for ClientMessageEvent
  cmAtom_XIM_PROTOCOL = XInternAtom( dpy, ATOM_XIM_PROTOCOL, False );
  cmAtom_XIM_XCONNECT = XInternAtom( dpy, ATOM_XIM_XCONNECT, False );
  cmAtom_XIM_MOREDATA = XInternAtom( dpy, ATOM_XIM_MOREDATA, False );

  cmAtom_NUNOME_POPUP = XInternAtom( dpy, ATOM_NUNOME_POPUP, False );
  cmAtom_AXE_SG_NUNOME = XInternAtom( dpy, ATOM_AXE_SG_NUNOME, False );

  // Atom for Communication Property with CM
  cmAtom_NUNOME_COMM = XInternAtom( dpy, ATOM_XIM_COMPROPERTY, False );
  
  //XUnGrabServer(dpy);
  oldDestroyDispatcher = XtSetEventDispatcher(dpy, DestroyNotify,
    dispatchDestroyHook);
  oldReparentDispatcher = XtSetEventDispatcher(dpy, ReparentNotify,
    dispatchReparentHook);
  return 0;
}




/*
 *   PreconnectionˡClientLOCALESTRANSPORTץѥƥʹƤ롣
 * ϡSelectionRequestEvent׵ᤵ롣ץѥƥŬڤͤ򥻥å
 * XEventǥץѥƥAtom򤪤롣
 */
static	int	ProcessSelectionRequestEvent( Display *dpy,
					      XSelectionRequestEvent *sr_ev )
{
  char			*locale_supported;
  char			tmp_prop[2048];
  XSelectionEvent	selev;
  int			sendev = 0;

  // selection̾ @server=_NUNOME Ǥ뤳
  if ( sr_ev->selection == atom_server_nunome ){
    if ( sr_ev->property == atom_locales ){	// LOCALESץѥƥ׵ξ
      // Ϥäȥݡȥ¿Ϥ
      locale_supported = setlocale( LC_ALL, "" );
      sprintf( tmp_prop, "%s%s", ATOM_XIM_LOCALE_NUNOME,
	       locale_supported );
      // LOCALESץѥƥ˥åȤ
      XChangeProperty( dpy, sr_ev->requestor, sr_ev->property,
		       sr_ev->target, 8, PropModeReplace,
		       tmp_prop, strlen(tmp_prop) );
      sendev = 1;
    }else if ( sr_ev->property == atom_transport ){	// TRANSPORTץѥƥ׵
      XChangeProperty( dpy, sr_ev->requestor, sr_ev->property,
		       sr_ev->target, 8, PropModeReplace,
		       ATOM_XIM_TRANSPORT_NUNOME,
		       strlen(ATOM_XIM_TRANSPORT_NUNOME) );
      sendev = 1;
    }else{
      fprintf(stderr,"Property Error\n");
    }
  }else{
    char	*selection_name;
    
    selection_name = XGetAtomName( sr_ev->display, sr_ev->selection );
#ifdef DEBUG_PRINT
    fprintf(stderr, "Request Selection Name is [%s]\n", selection_name );
#endif
    XFree( selection_name );
  }
  
// LOCALES or TRANSPORTΤȤXEvent
  if ( sendev ){
    memset( &(selev), 0, sizeof(XSelectionEvent) );
    selev.type = SelectionNotify;
    selev.requestor = sr_ev->requestor;
    selev.selection = sr_ev->selection;
    selev.target    = sr_ev->target;
    selev.property  = sr_ev->property;
    selev.time      = sr_ev->time;
    XSendEvent( dpy, sr_ev->requestor, False, NoEventMask,
		(XEvent *)&selev );
  }
  return 0;
}

void DisposeIMConnection(Window client_w)
{
  int idx;

  for (idx = 0;idx < NumImConnection;idx++) {
    if (im_connection[idx].use != 0 && im_connection[idx].client == client_w) {
      XtDestroyWidget(im_connection[idx].server);
      XimDestroyAllIC(idx);
      if (idx == NumImConnection-1) {
	  int i;

	  for (i = NumImConnection-2;i >= 0;i--) {
	    if (im_connection[i].use != 0) break;
	  }
	  NumImConnection = i+1;
	  if (NumImConnection == 0) {
	      free(im_connection);
	      im_connection = NULL;
	  } else {
	      im_connection = (ImConnectionRec *)
		realloc(im_connection,sizeof(ImConnectionRec)*NumImConnection);
	  }
      } else {
	  im_connection[idx].use = 0;
      }
      break;
    }
  }
}

static	int	CreateNewIMConnection( Window client_w, Widget server_w )
{
  int	idx;
  
  if ( NumImConnection > 0 ){
    void	*ptr;
    
    for (idx = 0;idx < NumImConnection;idx++) {
	if (im_connection[idx].use == 0) break;
    }
    if (idx >= NumImConnection) {
	idx = NumImConnection++;
	ptr = (void *)im_connection;
	im_connection = (ImConnectionRec *)
	  realloc(im_connection,sizeof(ImConnectionRec)*NumImConnection );
    }
  }else{
    idx = 0;
    NumImConnection = 1;
    im_connection = (ImConnectionRec *)
      malloc( sizeof(ImConnectionRec)*NumImConnection );
  }
  im_connection[idx].use = 1;
  im_connection[idx].client = client_w;
  im_connection[idx].server = server_w;
  return idx;
}



static	void	ReplyXCONNECT( Widget w, XClientMessageEvent *ev )
{
  Display		*dpy;
  Window		win;
  XClientMessageEvent	sendev;
  Widget		serv_w;
  Arg			args[10];
  Window                client_win;
  
  dpy = XtDisplay( w );
  win = XtWindow( w );

  XtSetArg( args[0], XtNwidth, 1 );
  XtSetArg( args[1], XtNheight, 1 );
  XtSetArg( args[2], XtNmappedWhenManaged, True );
  serv_w = XtCreateManagedWidget( "label", simpleWidgetClass, w,
				  args, 3 );
  XtAddEventHandler( serv_w, 0L, True, (XtEventHandler)CommWidgetEvHandler,
		     (XtPointer)NULL );
  XtRealizeWidget( serv_w );
  client_win = (Window)ev->data.l[0];
  CreateNewIMConnection( client_win, serv_w );
  XSync(dpy,False);
  IMHookXError();
  {
    Window root, parent, *children;
    unsigned int nchildren;

    XQueryTree(dpy,client_win,&root,&parent,&children,&nchildren);
    if (nchildren > 0) XFree(children);
    XSelectInput(dpy,parent,SubstructureNotifyMask);
  }
  memset( &sendev, 0, sizeof(XClientMessageEvent) );
  sendev.type    = ClientMessage;
  sendev.display = dpy;
  sendev.window  = client_win;
  sendev.message_type = cmAtom_XIM_XCONNECT;
  sendev.format  = 32;
  sendev.data.l[0] = XtWindow( serv_w );
  sendev.data.l[1] = 0;
  sendev.data.l[2] = 0;
  sendev.data.l[3] = 20;
  XSendEvent( dpy, client_win, False, NoEventMask,
	      (XEvent *)&sendev );
  XSync(dpy,False);
  if (IMUnhookXError() > 0) {
    DisposeIMConnection(client_win);
  }
}



/*
 *	_XIM_XCONNECT
 */
static	void	DispatchClientMessage( Widget w, XClientMessageEvent *cm_ev )
{
  // Dispatch with message_type
  if ( cm_ev->message_type == cmAtom_XIM_XCONNECT ){
    ReplyXCONNECT( w, cm_ev );
  }else if ( cm_ev->message_type == cmAtom_NUNOME_POPUP ){
#ifdef DEBUG_PRINT
    fprintf(stderr," Nunome popup\n");
#endif
    NnmPopup();
  }else{
    fprintf(stderr," Unknown message type %ul\n", (unsigned int)cm_ev->message_type);
  }
}

/* Application Toplevel Event Handler */
/*  Preconnection from Client on XEvent */
void	TopLevelEvHandler( Widget w, XtPointer clo,
			   XEvent *ev, Boolean *ctd )
{
  switch( ev->type ){
  case SelectionRequest:	// Property Request
#ifdef DEBUG_PRINT
    fprintf(stderr,"TopLevelEvHandler: SelectionRequest Event\n");
#endif
    ProcessSelectionRequestEvent( XtDisplay(w), 
				  (XSelectionRequestEvent *)ev );
    break;
  case ClientMessage:		// _XIM_XCONNECT
#ifdef DEBUG_PRINT
    fprintf(stderr,"TopLevelEvHandler: ClientMessage Event\n");
#endif
    DispatchClientMessage( w, (XClientMessageEvent *)ev );
    break;
  case PropertyNotify:
    fprintf(stderr,"TopLevelEvHandler: PropertyNotify Eventis not suepported\n");
    break;
  default:
    fprintf(stderr,"TopLevelEvHandler: Event %d is not supported\n", ev->type );
    break;
  }
}
