/* 
   $Id: nnmCommand.c,v 1.19 2002/07/05 03:51:46 shibajun Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "config.h"
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Simple.h>
#include <X11/keysym.h>
#ifdef USE_XTEST  
#include <X11/extensions/XTest.h>
#include <X11/xpm.h>
#endif

#include "./nnmUI.h"

#include "NnmProto.h"
#include "IMlib.h"

#define NNMDICMAN "nnmdicman"

#define KEYBOARD

#ifdef KEYBOARD

extern char *nnm_keymap;

struct nnm_kb{
  int   c;
  short x, y, w, h;
};

int    max_keys = 0;
struct nnm_kb nnm_keytbl[256];

static Widget kbdForm;
static Widget kbdList;

#define KIGOU_START 0x2100
#define KIGOU_END   0x7e00
#define KIGOU_COLUMN    8
#define KIGOU_RAW       4
#define KIGOU_DISP_MAX  32

static Widget kigouForm, kigouCommandForm;
static Widget kigouList;
static Widget kigouRETBtn;
static int    kigouPage = 0;

char    kigou_codes[KIGOU_DISP_MAX][3];
String  kigou_list[KIGOU_DISP_MAX + 1];

static Widget jisPopShell;
static Widget jisForm;
static Widget jisNumBtns[16];
static Widget jisCodeLabel;
static Widget jisCodeBtn;
static int    currentCode = 0;

#endif /* KEYBOARD */

static Boolean support_xtest = 0;

void    InitSendEventKey( Display *dpy)
{
#ifdef USE_XTEST  
  int event_base, error_base, major_version, minor_version;

  support_xtest = XTestQueryExtension(dpy, &event_base, &error_base, 
				      &major_version, &minor_version);

#ifdef DEBUG_PRINT
  if(support_xtest){
    fprintf(stderr, "event_base: %x\n", event_base);
    fprintf(stderr, "errot_base: %x\n", error_base);
    fprintf(stderr, "major_version: %x\n", major_version);
    fprintf(stderr, "minor_version: %x\n", minor_version);
  }
#endif
#endif /* USE_XTEST */
}

void	SendEventKey( Display *dpy, unsigned int keysym,
  unsigned int state, int pressed)
{
  Window		sender;
  XEvent		ev;
  int                   j;

#ifdef DEBUG_PRINT
  fprintf(stderr," KeyPressEvent(keysym %3X:state %3X) --> ",
	 keysym, state );
#endif

  if(!support_xtest){
    int evmask = pressed != 0 ? KeyPressMask : KeyReleaseMask;

    XGetInputFocus(dpy, &sender, &j);
    ev.type = pressed != 0 ? KeyPress : KeyRelease;
    ev.xany.display= dpy;
    ev.xkey.window    = sender;
    ev.xkey.root      = DefaultRootWindow(dpy);
    ev.xkey.state     = state;
    ev.xkey.keycode   = XKeysymToKeycode(dpy, keysym);
    XSendEvent( dpy, sender, True, evmask,
		(XEvent *)&ev );
#ifdef DEBUG_PRINT
    fprintf(stderr, "Use XSendEvent\n");
#endif

#ifdef USE_XTEST
  }else{
    XTestFakeKeyEvent(dpy, XKeysymToKeycode(dpy, keysym), pressed != 0, 0);
#ifdef DEBUG_PRINT
    fprintf(stderr, "Use XTestFakeKeyEvent\n");
#endif /* DEBUG_PRINT */
#endif /* USE_XTEST */
  }

#ifdef DEBUG_PRINT
  fprintf(stderr," Send XIM_FORWARD_EVENT");
  fprintf(stderr,"\n");
#endif
}

/*
 *  ǧButton WidgetCallbackؿ
 *
 */
static void	RecogBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
#ifdef WNN
  {
      extern int IsConv; 
      if(IsConv){
	RevConv();
      }
  }
#endif /* WNN */
  /* -1 ϼʸȤ̵Ȥ̣ */
  NnmRemoveTimeOut();
  NnmCurrentCanvasRecognize( -1, 1 );
}

#ifdef WNN
static void	ConvBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmTransResult();
}
#endif /* WNN */

/*
 *  Popdown button widgetCallback
 */
#if 0
static void	PopdownBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmPopdown();
}
#endif

static void	RegBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
    char buf[4096];
    extern int serverPID;
    extern char *user_dictionary;

    sprintf(buf,"%s -p %d %s &", NNMDICMAN, serverPID, user_dictionary);
    system(buf);
}

static void	BSBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultBackSpace();
}

static void	ESCBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultESCKey();
}


static void	CRBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultCRKey();
  XimSendKey( 0x000a );
}

static void	ENTBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  NnmResultCRKey();
}

static void	SPCBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
#ifdef WNN
  extern int IsConv;
  if(!IsConv)
#endif WNN
    NnmResultInsertChar( 0x0020 );
}

static void	KBDBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  MapKBDForm();
  UnmapTopForm();
  UnmapKigouForm();
}

static void	KigouBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  NnmCandPopdown();
  MapKigouForm();
  UnmapTopForm();
  UnmapKBDForm();
}

static Widget 	CreateButton( char *name, Widget parent)
{
  Arg		carg[10];
  int		i;
  Widget	w;

  i = 0;
  w = XtCreateManagedWidget( name, commandWidgetClass,
			     parent, carg, i );
  return w;
}

#if 0
static Widget 	CreateToggle( char *name, Widget parent, 
			      Widget fromHoriz, Widget fromVert )
{
  Arg		carg[10];
  int		i;
  Widget	w;

  i = 0;
  w = XtCreateManagedWidget( name, toggleWidgetClass,
			     parent, carg, i );
  return w;
}

#define NNM_TGL_NUM   1
#define NNM_TGL_KIGOU 2
#define NNM_TGL_KATA  4
#define NNM_TGL_HIRA  8
static int	TglState = 0;
#endif

/*
 *
 *
 */

Widget	CreateCommandWidgets( char *name, Widget parent, 
			      Arg args[], int num )
{
  Widget	CommandForm, w;
  Widget	RecogBtn;
  Widget	EscBtn, CRBtn, ENTBtn, SPCBtn, BSBtn, KBDBtn;
  Widget	KigouBtn, RegBtn;
#ifdef WNN
  Widget	ConvBtn;
#endif

  CommandForm = XtCreateManagedWidget( name, formWidgetClass,
				       parent, args, num );

  w = EscBtn = CreateButton( "esc", CommandForm);
  XtAddCallback( w, XtNcallback, ESCBtnProc, NULL );

  w = SPCBtn = CreateButton( "spc", CommandForm);
  XtAddCallback( w, XtNcallback, SPCBtnProc, NULL );

  w = CRBtn = CreateButton( "cr", CommandForm);
  XtAddCallback( w, XtNcallback, CRBtnProc, NULL );

  w = ENTBtn = CreateButton( "ent", CommandForm);
  XtAddCallback( w, XtNcallback, ENTBtnProc, NULL );

  w = RecogBtn = CreateButton( "recog", CommandForm);
  XtAddCallback( w, XtNcallback, RecogBtnProc, NULL );

#ifdef WNN
  w = ConvBtn = CreateButton( "conv", CommandForm );
  XtAddCallback( w, XtNcallback, ConvBtnProc, NULL );
#endif /* WNN */

  w = BSBtn = CreateButton( "bs", CommandForm );
  XtAddCallback( w, XtNcallback, BSBtnProc, NULL );

  w = RegBtn = CreateButton( "reg", CommandForm );
  XtAddCallback( w, XtNcallback, RegBtnProc, NULL );

#ifdef KEYBOARD 
  w = KBDBtn = CreateButton( "kbd", CommandForm );
  XtAddCallback( w, XtNcallback, KBDBtnProc, NULL );

  w = KigouBtn = CreateButton( "kigou", CommandForm);
  XtAddCallback( w, XtNcallback, KigouBtnProc, NULL );
#endif /* KEYBOARD */

  return CommandForm;
}

#ifdef KEYBOARD

static int keyMask = 0;

Pixmap         kb_pm = 0;
int            kb_width, kb_height;
int            kb_x_hot, kb_y_hot;
GC             gc;
unsigned char  *keybmp_data;
XpmImage       keyim_data;

static void RedrawKeyboard()
{
  int     i, h;
  Display *dpy = XtDisplay(kbdList);
  Window  win  = XtWindow(kbdList);
  
  if(!kb_pm){
    XpmCreatePixmapFromXpmImage(dpy, win, &keyim_data, &kb_pm, NULL, NULL);
  }

  for(i = 0; i < max_keys; i++){
    if ((keyMask & LockMask)
	 && (((nnm_keytbl[i].c >= XK_A) && (nnm_keytbl[i].c <= XK_Z))
	 || ((nnm_keytbl[i].c >= XK_a) && (nnm_keytbl[i].c <= XK_z)))) {
	    h = kb_height/2;
    } else {
      h = (keyMask & ShiftMask) ? kb_height / 2 : 0;
    }

    switch(nnm_keytbl[i].c){
    case XK_Shift_L:
    case XK_Shift_R:
      if(keyMask & ShiftMask) XSetFunction(dpy,gc, GXcopyInverted);
      else        XSetFunction(dpy,gc, GXcopy);
      break;

    case XK_Control_L:
    case XK_Control_R:
      if(keyMask & ControlMask)  XSetFunction(dpy,gc, GXcopyInverted);
      else        XSetFunction(dpy,gc, GXcopy);
      break;

    case XK_Alt_L:
    case XK_Alt_R:
      if(keyMask & Mod1Mask)  XSetFunction(dpy,gc, GXcopyInverted);
      else        XSetFunction(dpy,gc, GXcopy);
      break;

    case XK_Caps_Lock:
      if(keyMask & LockMask)  XSetFunction(dpy,gc, GXcopyInverted);
      else        XSetFunction(dpy,gc, GXcopy);
      break;

    default:
      XSetFunction(dpy,gc, GXcopy);
      break;
    }

    XCopyArea(dpy, kb_pm, win, gc,
#ifdef __NUNOME_VGA__
	nnm_keytbl[i].x-KBD_OFFSET, nnm_keytbl[i].y + h,
#else
	nnm_keytbl[i].x, nnm_keytbl[i].y + h,
#endif
	nnm_keytbl[i].w, nnm_keytbl[i].h,
	nnm_keytbl[i].x, nnm_keytbl[i].y);

  }
}

static void ClickShiftKey(Widget w, int i)
{
  Display *dpy = XtDisplay(w);

  if (keyMask & ShiftMask) {
    SendEventKey( dpy, XK_Shift_L, keyMask, 0);
    keyMask &= ~ShiftMask;
  }else{
    SendEventKey( dpy, XK_Shift_L, keyMask, 1);
    keyMask |= ShiftMask;
  }
  RedrawKeyboard();
}

static void ClickAltKey(Widget w, int i)
{
  Display *dpy = XtDisplay(w);

  if (keyMask & Mod1Mask){
    SendEventKey( dpy, XK_Alt_L, keyMask, 0);
    keyMask &= ~Mod1Mask;
  }else{
    SendEventKey( dpy, XK_Alt_L, keyMask, 1);
    keyMask |= Mod1Mask;
  }
  RedrawKeyboard();
}

static void ClickControlKey(Widget w, int i)
{
  Display *dpy = XtDisplay(w);

  if (keyMask & ControlMask){
    SendEventKey( dpy, XK_Control_L, keyMask, 0);
    keyMask &= ~ControlMask;
  }else{
    SendEventKey( dpy, XK_Control_L, keyMask, 1);
    keyMask |= ControlMask;
  }
  RedrawKeyboard();
}

static void ClickCapsKey(Widget w, int i)
{
  Display *dpy = XtDisplay(w);

  if (keyMask & LockMask) {
    SendEventKey( dpy, XK_Caps_Lock, keyMask, 0);
    keyMask &= ~LockMask;
  }else{
    SendEventKey( dpy, XK_Caps_Lock, keyMask, 1);
    keyMask |= LockMask;
  }
  RedrawKeyboard();
}

static void ClickNormalKey(Widget w, int i, int pressed)
{
  Display *dpy = XtDisplay(w);

  SendEventKey( dpy, nnm_keytbl[i].c, keyMask, pressed);
  if (!pressed) {
      if(keyMask & ShiftMask){
	SendEventKey( dpy, XK_Shift_L, keyMask, 0);
	keyMask &= ~ShiftMask;
      }
      if(keyMask & ControlMask){
	SendEventKey( dpy, XK_Control_L, keyMask, 0);
	keyMask &= ~ControlMask;
      }
      if(keyMask & Mod1Mask){
	SendEventKey( dpy, XK_Alt_L, keyMask, 0);
	keyMask &= ~Mod1Mask;
      }
      RedrawKeyboard();
  }
}

static int pressed_key = -1;

static void PressKeyboard(Widget w, XtPointer clo, XButtonEvent *ev, Boolean *ctd)
{
  int i;
  Display *dpy = XtDisplay(w);
  Window  win  = XtWindow(w);

  for(i = 0; i < max_keys; i++){
    if( (nnm_keytbl[i].x <= ev->x) 
	&& (ev->x <= nnm_keytbl[i].x + nnm_keytbl[i].w)
	&& (nnm_keytbl[i].y <= ev->y)
	&& (ev->y <= nnm_keytbl[i].y + nnm_keytbl[i].h)){

      pressed_key = i;

      switch(nnm_keytbl[i].c){
      case XK_Henkan_Mode:
      case XK_Shift_L:
      case XK_Shift_R:
      case XK_Control_L:
      case XK_Control_R:
      case XK_Caps_Lock:
	break;

      default:
	ClickNormalKey(w, i, 1);
	break;
      }
      XSetFunction( dpy, gc, GXinvert);
      XFillRectangle( dpy, win, gc, 
		      nnm_keytbl[i].x, nnm_keytbl[i].y,
		      nnm_keytbl[i].w, nnm_keytbl[i].h);
      break;
    }
  }
}

static void LeaveKeyboard(Widget w, XtPointer clo, XMotionEvent *ev, Boolean *ctd)
{
  if(pressed_key >= 0){
    pressed_key = -1;
    RedrawKeyboard();
  }
}

static void MotionKeyboard(Widget w, XtPointer clo, XMotionEvent *ev, Boolean *ctd)
{
  int i;

  for(i = 0; i < max_keys; i++){
    if( (nnm_keytbl[i].x <= ev->x) 
	&& (ev->x <= nnm_keytbl[i].x + nnm_keytbl[i].w)
	&& (nnm_keytbl[i].y <= ev->y)
	&& (ev->y <= nnm_keytbl[i].y + nnm_keytbl[i].h)){
      if(pressed_key != i){
	pressed_key = -1;
	RedrawKeyboard();
	break;
      }
    }
  }
}

static void ReleaseKeyboard(Widget w, XtPointer clo, XButtonEvent *ev, Boolean *ctd)
{
  int i;

  if(pressed_key == -1) return;
   
  for(i = 0; i < max_keys; i++){
    if( (nnm_keytbl[i].x <= ev->x) 
	&& (ev->x <= nnm_keytbl[i].x + nnm_keytbl[i].w)
	&& (nnm_keytbl[i].y <= ev->y)
	&& (ev->y <= nnm_keytbl[i].y + nnm_keytbl[i].h)){
      
      pressed_key = -1;

      switch(nnm_keytbl[i].c){
      case XK_Henkan_Mode:
	MapTopForm();
	UnmapKBDForm();
	UnmapKigouForm();
	break;
	
      case XK_Shift_L:
      case XK_Shift_R:
	ClickShiftKey(w, i);
	break;
	
      case  XK_Control_L:
      case  XK_Control_R:
	ClickControlKey(w, i);
	break;
	
      case  XK_Alt_L:
      case  XK_Alt_R:
	ClickAltKey(w, i);
	break;
	
      case  XK_Caps_Lock:
	ClickCapsKey( w, i);
	break;

      default:
	ClickNormalKey(w, i, 0);
	break;
      }
      
      break;
    }
  }
}

void ReadKeyTable(char *keytbl_fn)
{
  FILE *fp;
  int  i, n ;

  fp = fopen((char *) keytbl_fn, "r");
  if(fp == NULL){
    fprintf(stderr, "can't open keymap file: %s", keytbl_fn);
    return;
  }
  
  n = 0;
  do{
    i = fread(&nnm_keytbl[n], sizeof(struct nnm_kb), 1, fp); 
#ifdef __NUNOME_VGA__
    nnm_keytbl[n].x += KBD_OFFSET ;
#endif
    if(i > 0) n++;
  }while((i > 0) && (n < 256));
  max_keys = n;

  fclose(fp);
}

Widget	CreateKBDWidgets( char *name, Widget parent, 
			  Arg cargs[], int num )
{
  Arg		args[10];
  int		i;
  char          *keybmp_fn[FILENAME_MAX];
  char          *keytbl_fn[FILENAME_MAX];

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  kbdForm = XtCreateManagedWidget( name, formWidgetClass,
				   parent, cargs, num );

  i = 0;
  /*
#ifdef __NUNOME_VGA__
  XtSetArg( args[i], XtNwidth, 628); i++;
  XtSetArg( args[i], XtNheight, 80); i++;
#else
  XtSetArg( args[i], XtNwidth, 230); i++;
  XtSetArg( args[i], XtNheight, 80); i++;
#endif
  */
  XtSetArg( args[i], XtNborderWidth, 0); i++;
  kbdList = XtCreateManagedWidget( "keyboard", simpleWidgetClass,
				   kbdForm, args, i );

  gc = XtGetGC(kbdList, 0, NULL);
  XtAddEventHandler( kbdList, ExposureMask, False,
		     (XtEventHandler) RedrawKeyboard, NULL );
  XtAddEventHandler( kbdList, ButtonPressMask, False,
		     (XtEventHandler) PressKeyboard, NULL );
  XtAddEventHandler( kbdList, ButtonReleaseMask, False,
		     (XtEventHandler) ReleaseKeyboard, NULL );
  XtAddEventHandler( kbdList, LeaveWindowMask, False,
		     (XtEventHandler) LeaveKeyboard, NULL );
  XtAddEventHandler( kbdList, ButtonMotionMask, False,
		     (XtEventHandler) MotionKeyboard, NULL );

  /*
  sprintf((char *)keybmp_fn, "%s/%s.xbm", PKGDATADIR, nnm_keymap);
  XReadBitmapFileData((char *)keybmp_fn, &kb_width, &kb_height, 
		      (unsigned char **) &keybmp_data, &kb_x_hot, &kb_y_hot);
  */  
  sprintf((char *)keybmp_fn, "%s/%s.xpm", PKGDATADIR, nnm_keymap);
  XpmReadFileToXpmImage((char *)keybmp_fn, &keyim_data, NULL);
  kb_width = keyim_data.width;
  kb_height = keyim_data.height;

  sprintf((char *) keytbl_fn,"%s/%s.tbl", PKGDATADIR, nnm_keymap);
  ReadKeyTable((char *) keytbl_fn);

  return kbdForm;
}

void   kigouNextBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  i;
  char s[256];

  kigouPage += 0x20;

  if((kigouPage & 0xff) >= 0x80) kigouPage = (kigouPage & 0xff00) + 0x100;
  if((kigouPage & 0xff) <= 0x20) kigouPage = (kigouPage & 0xff00) + 0x20;

  if((KIGOU_START + kigouPage) > 0x7e60) kigouPage = 0x7e60 - KIGOU_START;

  for( i = 0; i < KIGOU_DISP_MAX; i++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + i) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + i) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];
  }
  kigou_list[i] = NULL;
  XawListChange(kigouList, kigou_list, i, 0, True);

  sprintf(s, "%04x", kigouPage + KIGOU_START);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);

}

void   kigouPrevBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg  args[10];
  int  i;
  char s[256];

  kigouPage -= 0x20;

  if(kigouPage < 0x20){
    kigouPage = 0x20;
    return;
  }

  if((kigouPage & 0xff) >= 0x80 || ((kigouPage & 0xff)== 0))    
    kigouPage = (kigouPage & 0xff00) - 0xa0;
  else if((kigouPage & 0xff) < 0x20)       kigouPage = (kigouPage & 0xff00) - 0x80;

  for( i = 0; i < 0x20; i++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + i) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + i) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];
  }
  kigou_list[i] = NULL;
  XawListChange(kigouList, kigou_list, i, 0, True);

  sprintf(s, "%04x", kigouPage + KIGOU_START);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);

}

void   kigouRETBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  MapTopForm();
  UnmapKBDForm();
  UnmapKigouForm();
}

static void	kigouListProc( Widget w, XtPointer cli, XtPointer clo )
{
  XawListReturnStruct *list_return;
  int index;

  list_return = (XawListReturnStruct *) clo;
  index = list_return->list_index;
  XimSendString(list_return->string);
}

void NnmSetJisCodeBtnLabel(int code)
{
  Arg        args[10];
  int        i;
  char       s[256];

  while( (code != 0) && (code < 0xfff)) code <<=4;

  sprintf(s, "%04x", code);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeBtn, args, i);
}

static void NnmSetJisCodeLabelLabel(int code)
{
  Arg        args[10];
  int        i;
  char       s[256];

  while( (code != 0) && (code < 0xfff)) code <<=4;

  sprintf(s, "%04x", code);
  i = 0;
  XtSetArg( args[i], XtNlabel, s); i++;  
  XtSetValues( jisCodeLabel, args, i);
}

static void  jisNumBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  int        i, j, idx;
  char       s[256];

  idx = (int)cli;

  if( (currentCode > 0xff) && (currentCode < 0xfff) ) {
    currentCode <<= 4;
    currentCode += idx;

    s[0] = (currentCode & 0xff) | 0x80;
    s[1] = (currentCode >> 8)   | 0x80;
    s[2] = 0;
    XimSendString(s);

    currentCode = 0;
    NnmSetJisCodeBtnLabel(currentCode);
    NnmSetJisCodeLabelLabel(currentCode);

  }else if( (currentCode > 0xf) && (currentCode < 0xff) ) {
    currentCode <<= 4;
    currentCode += idx;

    kigouPage = ((currentCode << 4)& 0xffe0)- KIGOU_START;

    if(kigouPage < 0)
      currentCode = KIGOU_START >> 4, kigouPage = 0;
    else if(kigouPage > KIGOU_END - KIGOU_START)
      currentCode = KIGOU_END >> 4, kigouPage = KIGOU_END - KIGOU_START;

    if((kigouPage & 0xff) <= 0x20) kigouPage = (kigouPage & 0xff00) + 0x20;
    if((kigouPage & 0xff) >= 0x80) kigouPage = (kigouPage & 0xff00) + 0x120;

    for( i = j = 0; i < 0x20; i++,j++){
      kigou_codes[i][0] = ((KIGOU_START + kigouPage + j) >> 8)  | 0x80;
      kigou_codes[i][1] = ((KIGOU_START + kigouPage + j) & 0xff)| 0x80;
      kigou_codes[i][2] = '\0';
      kigou_list[i] = kigou_codes[i];
    }
    kigou_list[i] = NULL;
    XawListChange(kigouList, kigou_list, i, 0, True);

    NnmSetJisCodeBtnLabel(kigouPage + KIGOU_START);
    NnmSetJisCodeLabelLabel(currentCode);
  }else{
    currentCode <<= 4;
    currentCode += idx;
    NnmSetJisCodeBtnLabel(currentCode);
    NnmSetJisCodeLabelLabel(currentCode);
  }

}

static void  jisBSBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  currentCode >>= 4;
  NnmSetJisCodeBtnLabel(currentCode);
  NnmSetJisCodeLabelLabel(currentCode);
}

static void  jisCloseBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  XtPopdown(jisPopShell);
}


void	NnmCreateJISPopup( Widget top )
{
  Arg		args[10];
  int		i, num;
  Widget        bsBtn,closeBtn;

  jisPopShell = XtCreatePopupShell( "jisshell",
				      overrideShellWidgetClass,
				      top, NULL, 0 );
  jisForm = XtCreateManagedWidget( "jisform", formWidgetClass,
				   jisPopShell, NULL, 0 );

  num = 0;
  jisCodeLabel = XtCreateManagedWidget( "label", labelWidgetClass,
					jisForm, args, num );

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisCodeLabel ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  XtSetArg( args[num], XtNborderWidth, 1 ); num++;
  XtSetArg( args[num], XtNinternational, True ); num++;
  
  for( i = 0; i < 16; i++ ){
    char tmp[2048];
    char *table[] = { "0", "1", "2", "3", "4", "5", "6", "7",
		      "8", "9", "A", "B", "C", "D", "E", "F" };    

    sprintf( tmp, "%s", table[i]);
    jisNumBtns[i] = XtCreateManagedWidget( tmp, commandWidgetClass,
					jisForm, args, num );

    XtAddCallback( jisNumBtns[i], XtNcallback, jisNumBtnProc,
		   (XtPointer) i);
    
    
    if((i & 0x3) == 3){
      XtSetArg( args[0], XtNfromVert, jisNumBtns[ i & 0x0c] );
      XtSetArg( args[1], XtNfromHoriz, NULL );
    }
    else{
      XtSetArg( args[1], XtNfromHoriz, jisNumBtns[i] );
    }
  }

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisNumBtns[12] ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  bsBtn = XtCreateManagedWidget( "bs", commandWidgetClass,
				     jisForm, args, num);
  
  XtAddCallback( bsBtn, XtNcallback, jisBSBtnProc, NULL);

  num = 0;
  XtSetArg( args[num], XtNfromVert, jisNumBtns[12] ); num++;
  XtSetArg( args[num], XtNfromHoriz, bsBtn ); num++;
  closeBtn = XtCreateManagedWidget( "close", commandWidgetClass,
				     jisForm, args,  num);
  XtAddCallback( closeBtn, XtNcallback, jisCloseBtnProc, NULL );

}

void   jisCodeBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  Arg args[10];
  int x, y, width, height;
  int wx, wy;

  x = 0, y = 0, width = 0, height = 0;
  wx = 0, wy = 0;

  NnmGetWindowPos(w, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouCommandForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetWindowPos(kigouForm, &x, &y, &width, &height);
  wx += x, wy += y;

  NnmGetShellPos(&x, &y, &width, &height);
  wx += x, wy += y;

  currentCode = 0;
  NnmSetJisCodeLabelLabel(currentCode);

  XtSetArg( args[0], XtNx, wx );
  XtSetArg( args[1], XtNy, wy );
  XtSetValues( jisPopShell, args, 2 );

  XtPopup(jisPopShell, XtGrabNonexclusive );
}

Widget	CreateKigouWidgets( char *name, Widget parent, 
			      Arg cargs[], int num )
{
  Arg		args[10];
  int		i, j;
  Widget        kigouNextBtn, kigouPrevBtn;
  Widget        listForm, commandForm;
  char          s[256];

  kigouForm = XtCreateManagedWidget( name, formWidgetClass,
				     parent, cargs, num );

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  listForm = XtCreateManagedWidget( "listform", formWidgetClass,
				     kigouForm, args, num );

  num = 0;
  XtSetArg( args[num], XtNborderWidth, 0 ); num++;
  commandForm = XtCreateManagedWidget( "commandform", formWidgetClass,
				     kigouForm, args, num );
  kigouCommandForm = commandForm;

  kigouPage = 0x20;
  for( i = j = 0; i < KIGOU_DISP_MAX; i++,j++){
    kigou_codes[i][0] = ((KIGOU_START + kigouPage + j) >> 8) | 0x80;
    kigou_codes[i][1] = ((KIGOU_START + kigouPage + j) & 0xff)| 0x80;
    kigou_codes[i][2] = '\0';
    kigou_list[i] = kigou_codes[i];    
  }
  kigou_list[KIGOU_DISP_MAX] = NULL;

  i = 0;
  XtSetArg( args[i], XtNdefaultColumns, KIGOU_COLUMN); i++;  
  XtSetArg( args[i], XtNlabel, "list" ); i++;
  XtSetArg( args[i], XtNlist, kigou_list ); i++;
  kigouList = XtCreateManagedWidget( "list", listWidgetClass,
				   listForm, args, i );
  XtAddCallback( kigouList, XtNcallback, kigouListProc, NULL );

  i = 0;
  sprintf(s, "%04x", kigouPage + KIGOU_START);
  XtSetArg( args[i], XtNlabel, s); i++; 
  jisCodeBtn = XtCreateManagedWidget( "code", commandWidgetClass,
				       commandForm, args,  i);
  XtAddCallback( jisCodeBtn, XtNcallback, jisCodeBtnProc, NULL );
  
  i = 0;
  kigouPrevBtn = XtCreateManagedWidget( "prev", commandWidgetClass,
					commandForm, args,  i);
  XtAddCallback( kigouPrevBtn, XtNcallback, kigouPrevBtnProc, NULL );

  i = 0;
  kigouNextBtn = XtCreateManagedWidget( "next", commandWidgetClass,
					commandForm, args,  i);
  XtAddCallback( kigouNextBtn, XtNcallback, kigouNextBtnProc, NULL );

  i = 0;
  kigouRETBtn = XtCreateManagedWidget( "return", commandWidgetClass,
				       commandForm, args,  i);
  XtAddCallback( kigouRETBtn, XtNcallback, kigouRETBtnProc, NULL );
  return kigouForm; 
}
#endif /* KEYBOARD */
