/* 
   $Id: nnmRecogField.c,v 1.25 2002/06/27 05:51:26 shibajun Exp $

   Copyright (C) 2001, 2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/keysym.h>

#include "./nnmUI.h"

#include "NnmProto.h"
#include "IMlib.h"
#include "nnmCanvas.h"
#include "nnmStub.h"


extern int  IsWriteSample;

#ifdef WNN 

//extern struct wnn_buf *wnnbuf;
int    IsConv = 0;
static int    currentKouho = 0;
static int    zenkouhoSuu = 0;
static int    currentKouhoPage = 0;
#endif /* WNN */


// ǧbufferǧʸ
static int			NumRecogChar = 0;	
// ǧbufferʸΥȥǡ
static NnmCanvasRec	*result_charInfo = 0;
// ǧbufferǧʸ
static unsigned long		result_code[MAX_DISP_RESULT];
static NnmFeatureRec		result_fv[MAX_DISP_RESULT];
// ǧbufferǧ̸ʸ
static unsigned long		cands_code[MAX_DISP_RESULT][MAX_CANDIDATE_CATEGORY];

// ǧɽwidget
static Widget		result_widgets[MAX_DISP_RESULT];

// ʸɽPopup widget
static Widget		candPopShell, candForm;
static Widget		candBtns[MAX_DISP_CANDIDATE];
// ǧɽwidgetΤɤwidgetθʸPopupƤ뤫
static int		currentRecogIdx = -1;
static Widget		nextCand,prevCand,clearCand;
static int              currentCandPage = 0;

static int		IsCandPopup = 0;

#ifdef WNN
#define MAX_DISP_KOUHO  4
static Widget		kouhoPopShell, kouhoForm;
static Widget		nextKouho,prevKouho;
static Widget		kouhoBtns[MAX_DISP_KOUHO];
#endif WNN

void NnmInitRecognizeField()
{
    if (IsWriteSample) {
	result_charInfo = (NnmCanvasRec*)calloc(sizeof(NnmCanvasRec),MAX_DISP_RESULT);
    }
}

/*
 *  ǧ̤ɽƤ widget ɽƤ
 *ʸɤѹ롣
 */
static void	NnmBtnChangeCode( int idx, unsigned long code )
{
  Arg	args[10];
  int	i;
  char	str[3];

  result_code[idx] = code;
  if ( (code>>8) ){
    /* 2byte JISξ */
    str[0] = (code>>8)|0x80;
    str[1] = (code & 0xff)|0x80;
    str[2] = 0;
  }else{
    /* 1byteɤξ */
    str[0] = code & 0xff;
    str[1] = 0;
  }
  i = 0;
  XtSetArg( args[i], XtNlabel, str ); i++;
  XtSetValues( result_widgets[idx], args, i ); 
}


/*
 *  ǧ̤ɽƤ widget  Clear 
 */
static void	NnmBtnClear( int idx )
{
  NnmBtnChangeCode( idx, 0x0000 );
}

static void doCommitResult(int idx, int len)
{
  int	i, j;
  char	commitstr[MAX_DISP_RESULT*2+1];

  if ( idx >= NumRecogChar) return;
  j = 0;
  for( i=idx; i< idx+len; i++ ){
    if (result_code[i] == 0) continue;
    if ( (result_code[i]>>8)!=0 ){
      commitstr[j++] = ((result_code[i]>>8)&0xff) | 0x80;
      commitstr[j++] = (result_code[i]&0xff) | 0x80;
#ifdef WNN
      if(!IsConv && IsWriteSample)
	NnmStubSampleAppendFile(&(result_charInfo[i].CharInfo),
	  result_code[i],"stroke.sam");
#else
      if(IsWriteSample)
	NnmStubSampleAppendFile(&(result_charInfo[i].CharInfo),
	  result_code[i],"stroke.sam");
#endif
    }else{
      commitstr[j++] = result_code[i]&0x7f;
#ifdef WNN
      if(!IsConv && IsWriteSample && result_code[i] != ' ')
	NnmStubSampleAppendFile(&(result_charInfo[i].CharInfo),
	  result_code[i],"stroke.sam");
#else
      if(IsWriteSample && result_code[i] != ' ')
	NnmStubSampleAppendFile(&(result_charInfo[i].CharInfo),
	  result_code[i],"stroke.sam");
#endif
    }
    if (result_code[i] != cands_code[i][0]) {
#ifdef NO_LEARN
#else
	extern int learn_flag; /* in nnmime.c */
	if(learn_flag){
	  NnmStubUpdateUserDictionary(result_code[i], &(result_fv[i]));
	}
#endif
    }
    NnmBtnClear( i );
  }
  commitstr[j] = 0;

  XimSendString( commitstr );
}

static void NnmShiftRecogChars(void)
{
    int i;

    doCommitResult(0,1);
    for (i = 1;i < NumRecogChar;i++) {
	result_code[i-1] = result_code[i];
	result_fv[i-1] = result_fv[i];
	memcpy(&(cands_code[i-1][0]),&(cands_code[i][0]),
	  sizeof(unsigned long)*MAX_CANDIDATE_CATEGORY);
        NnmBtnChangeCode( i-1, result_code[i-1] );
    }
    NumRecogChar--;
    if (currentRecogIdx > 0) {
	currentRecogIdx--;
    } else if (currentRecogIdx == 0) {
	if ( IsCandPopup ) XtPopdown( candPopShell );
        currentRecogIdx = -1;
        currentCandPage = 0;
    }
}


/*
 *  ǧ+ȥǧbuffer˳Ǽ
 */
void	NnmAppendResult( unsigned long code, NnmRawCharInfoRec *charInfo,
			 ulong cands[], NnmFeatureRec *fv)
{	
  int		i;
  int cidx;

  for (i = 0;i < NumRecogChar;i++) {
    if (result_code[i] == 0) break;
  }
  cidx = i;
  if (cidx >= MAX_DISP_RESULT) {
    NnmShiftRecogChars();
    cidx--;
  }
  if (IsWriteSample) {
    memcpy( &(result_charInfo[cidx].CharInfo), charInfo,
	sizeof( NnmRawCharInfoRec ) );
  }
  result_code[cidx] = code;
  result_fv[cidx] = *fv;
  for( i=0; i<MAX_CANDIDATE_CATEGORY; i++ ){
    cands_code[cidx][i] = cands[i];
  }
  NnmBtnChangeCode( cidx, code );
  if (cidx == NumRecogChar) {
    NumRecogChar++;
  }
}

/*
 *  ʸɤǧbuffer˳Ǽ롣
 */
void	NnmResultInsertChar( unsigned long code )
{
  int		i;
  int cidx;

  for (i = 0;i < NumRecogChar;i++) {
    if (result_code[i] == 0) break;
  }
  cidx = i;
  if (cidx >= MAX_DISP_RESULT) {
    NnmShiftRecogChars();
    cidx--;
  }
  if (IsWriteSample) {
    memset( &(result_charInfo[cidx].CharInfo), 0,
	sizeof( NnmRawCharInfoRec ) );
  }
  result_code[cidx] = code;
  for( i=0; i<MAX_CANDIDATE_CATEGORY; i++ ){
    cands_code[cidx][i] = code;
  }
  NnmBtnChangeCode( cidx, code );
  if (cidx == NumRecogChar) {
    NumRecogChar++;
  }
}


/*
 *  ǧbufferõ롣
 */
void	NnmResultAllClear(void)
{
  int	k;

  NnmCurrentCanvasClear();
  memset( result_code, 0, sizeof(result_code) );
  if (NumRecogChar > 0) {
    for( k=0; k<MAX_DISP_RESULT; k++ ){
      NnmBtnClear( k );
    }
    NumRecogChar = 0;
  } else {
    SendEventKey( XtDisplay(result_widgets[0]), XK_Delete, 0, 1);
    SendEventKey( XtDisplay(result_widgets[0]), XK_Delete, 0, 0);
  }
#ifdef WNN
  IsConv = 0;
  zenkouhoSuu = 0;
  currentKouhoPage = 0;
  currentKouho = 0;
  currentCandPage = 0;
#endif /* WNN */
}


/*
 *  BackSpaceܥư
 *    ڥΥХΥꥢ
 *    ʳϡǧbufferκǸΰʸõ
 */
void	NnmResultBackSpace( void )
{
#ifdef WNN
  if(IsConv){
    int	i;
    wchar yomi[256];
    IsConv = 0;

    NnmGetYomi(yomi);
    NumRecogChar = wchstrlen(yomi);

    for( i=0; i<NumRecogChar; i++ ){
      if ( (yomi[i]>>8)!=0 ){
	result_code[i] = yomi[i] & 0x7f7f;
      }else{
	result_code[i] = yomi[i] & 0xff;
      }
      NnmBtnChangeCode( i, result_code[i] );
    }
    result_code[i] = 0;
    
  }else{
#endif
    if ( NnmCurrentCanvasClear() == -1 ){
      if (NumRecogChar > 0) {
        NumRecogChar--;
	result_code[NumRecogChar] = 0;
	NnmBtnClear( NumRecogChar );
	while (NumRecogChar > 0 && result_code[NumRecogChar-1] == 0) NumRecogChar--;
      } else {
	SendEventKey( XtDisplay(result_widgets[0]), XK_BackSpace, 0, 1);
	SendEventKey( XtDisplay(result_widgets[0]), XK_BackSpace, 0, 0);
      }
    }
#ifdef WNN
  }
#endif /* WNN */
}


void	NnmResultESCKey( void )
{
  if ( NnmCurrentCanvasClear() == -1 ){
    NnmResultAllClear();
  }
}


void	NnmResultCRKey( void )
{
  //  NnmCurrentCanvasRecognize( -1 );
  NnmCommitResult();
}

void	NnmCommitResult( void )
{
  if ( NumRecogChar <= 0 ) return;
  doCommitResult(0,NumRecogChar);
  NumRecogChar = 0;
#ifdef WNN
  IsConv = 0;
  zenkouhoSuu = 0;
  currentKouhoPage = 0;
  currentKouho = 0;
  currentCandPage = 0;
#endif /* WNN */
}

#ifdef WNN
void	NnmTransResult( void )
{
  wchar string[1024];
  wchar kanji[1024];
  int   i,j;

  if(NumRecogChar <= 0) return;

  if(IsConv){
    currentKouho++;
    if(zenkouhoSuu <= currentKouho) currentKouho = 0;
    
    NnmGetZenkouho(currentKouho, kanji);
    for( i=0; i<MAX_DISP_RESULT; i++ ){
      NnmBtnChangeCode( i, 0 );
    }

  }else{

    for( i=0; i<NumRecogChar; i++ ){
      if ( (result_code[i]>>8)!=0 ){
	string[i] = result_code[i] | 0x8080;
      }else{
	string[i] = result_code[i] & 0x7f;
      }
    }
    string[i] = 0;
    
    bzero(kanji, sizeof(wchar)*1024 );
    zenkouhoSuu = NnmTanHenkan(string,kanji);
    if(zenkouhoSuu <= 0) return;

    for( i=0; i<MAX_DISP_RESULT; i++ ){
      NnmBtnClear(i);
    }
  }
  
  NumRecogChar = wchstrlen(kanji);

  for( i=j=0; i<NumRecogChar; i++ ){
    if ( (kanji[i]>>8)!=0 ){
      result_code[i] = kanji[i] & 0x7f7f;
    }else{
      result_code[i] = kanji[i] & 0xff;
    }
    NnmBtnChangeCode( i, result_code[i] );
  }
  result_code[i] = 0;

  IsConv = 1;
  currentKouhoPage = 0;
}
#endif /* WNN */



void	NnmCandPopdown( void )
{
  XtPopdown( candPopShell );
  currentRecogIdx = -1;
  currentCandPage = 0;
#ifdef WNN
  XtPopdown( kouhoPopShell );
#endif
}

extern  Widget	CanvasForm, CommandForm, ResultForm;

void NnmGetWindowPos(w, x, y, width, height)
     Widget w;
     int    *x, *y, *width, *height;
{
  Arg args[10];

  args[0].name = "x";
  args[0].value = (XtArgVal) x;
  args[1].name = "y";
  args[1].value = (XtArgVal) y;
  args[2].name = "width";
  args[2].value = (XtArgVal) width;
  args[3].name = "height";
  args[3].value = (XtArgVal) height;
  XtGetValues( w, args, 4);
}

static void		ShowCand( Widget w, XtPointer cli, XtPointer clo )
{	
  int			j, idx, num;
  Arg			args[10];
#ifdef WNN
  int i;
  static int IsKouhoPopup = 0;
#endif

  int wx, wy, ww, wh;
  int x = 0, y = 0, width = 0, height = 0;


#ifdef WNN
  if(IsConv){
    currentRecogIdx = idx = (int)cli;
    if ( idx >=  NumRecogChar){
      return;
    }
    if ( IsKouhoPopup ) XtPopdown( kouhoPopShell );

    wx = 0, wy = 0, ww = 0, wh = 0;
    x = 0, y = 0, width = 0, height = 0;
    NnmGetWindowPos(result_widgets[idx], &x, &y, &width, &height);
    wx += x, wy += y, ww += width, wh += height;
    
    x = 0, y = 0;
    NnmGetResultFormPos(&x, &y, &width, &height);
    wx += x, wy += y;
    
    x = 0, y = 0;
    NnmGetShellPos(&x, &y, &width, &height);
    wx += x, wy += y;
    
    XtSetArg( args[0], XtNx, wx );
    XtSetArg( args[1], XtNy, wy + wh);

    XtSetValues( kouhoPopShell, args, 2 );
    XtPopup( kouhoPopShell, XtGrabNonexclusive );
    IsKouhoPopup = 1;

    if(  zenkouhoSuu / MAX_DISP_KOUHO > currentKouhoPage)
      i = MAX_DISP_KOUHO;
    else 
      i = zenkouhoSuu % MAX_DISP_KOUHO;

    for( j = 0; j < MAX_DISP_KOUHO ; j++ ){
      num = 0;
      XtSetArg( args[num], XtNlabel, ""); num++;
      XtSetValues( kouhoBtns[j], args, num );
    }

    for( j = 0; j < i ; j++ ){
      unsigned char code_str[256];
      wchar temp[256];
      
      bzero(temp, sizeof(wchar)*256);

      NnmGetZenkouho((currentKouhoPage * MAX_DISP_KOUHO) + j, temp);
      wch2uch((wchar *)temp, (unsigned char *)code_str);

      num = 0;
      XtSetArg( args[num], XtNlabel, code_str ); num++;
      XtSetValues( kouhoBtns[j], args, num );
    }
  }else{
#endif
  currentCandPage = 0;
  currentRecogIdx = idx = (int)cli;
  if ( IsCandPopup ) XtPopdown( candPopShell );
  if ( result_code[idx] <= 0 ){
    return;
  }

  wx = 0, wy = 0, ww = 0, wh = 0;
  x = 0, y = 0, width = 0, height = 0;
  NnmGetWindowPos(result_widgets[idx], &x, &y, &width, &height);
  wy += y, ww += width, wh += height;

  x = 0, y = 0;
  NnmGetResultFormPos(&x, &y, &width, &height);
  wx += x, wy += y;

  x = 0, y = 0;
  NnmGetShellPos(&x, &y, &width, &height);
  wx += x, wy += y;

  XtSetArg( args[0], XtNx, wx );
  XtSetArg( args[1], XtNy, wy + wh);
  XtSetValues( candPopShell, args, 2 );
  XtPopup( candPopShell, XtGrabNonexclusive );
  IsCandPopup = 1;

  for( j = 0; j < MAX_DISP_CANDIDATE ; j++ ){
    num = 0;
    XtSetArg( args[num], XtNlabel, ""); num++;
    XtSetValues( candBtns[j], args, num );
  }

  for( j=0; j<MAX_DISP_CANDIDATE; j++ ){
    char	code_str[3];

    code_str[0] = (cands_code[idx][j]>>8)|0x80;
    code_str[1] =  cands_code[idx][j]    |0x80;
    code_str[2] = 0;
    num = 0;
    XtSetArg( args[num], XtNlabel, code_str ); num++;
    XtSetValues( candBtns[j], args, num );
  }
#ifdef WNN
  }
#endif /* WNN */
}

void	NnmCreateResultWidgets( Widget parent )
{
  int			i, j;
  Arg			carg[10];

  j = 0;
  XtSetArg( carg[j], XtNfromHoriz, NULL ); j++;
  XtSetArg( carg[j], XtNfromVert,  NULL ); j++;
  XtSetArg( carg[j], XtNborderWidth, 1 ); j++;
  XtSetArg( carg[j], XtNhorizDistance, 0 ); j++;
  XtSetArg( carg[j], XtNvertDistance, 0 ); j++;
  XtSetArg( carg[j], XtNlabel, ""); j++;
#ifdef __NUNOME_VGA__
  //XtSetArg( carg[j], XtNwidth, 14); j++; 
  //XtSetArg( carg[j], XtNheight, 14); j++;
  XtSetArg( carg[j], XtNresize, FALSE); j++; // fix widget size
#endif
  for( i=0; i<MAX_DISP_RESULT; i++ ){
    char	tmp[256];

    sprintf( tmp, "%02d", i );
    result_widgets[i] = XtCreateManagedWidget( tmp, commandWidgetClass,
					   parent, carg, j );

    XtAddCallback( result_widgets[i], XtNcallback,
		   ShowCand, (XtPointer)i );
    XtSetArg( carg[0], XtNfromHoriz, result_widgets[i] );
  }
}


static void	clearCandProc( Widget w, XtPointer cli, XtPointer clo )
{
  if ( currentRecogIdx != -1 ){
    result_code[currentRecogIdx] = 0;
    NnmBtnClear(currentRecogIdx);
    while (NumRecogChar > 0 && result_code[NumRecogChar-1] == 0) NumRecogChar--;
  }
  XtPopdown( candPopShell );

  currentRecogIdx = -1;
  currentCandPage = 0;
}


static void	candBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  unsigned long	code;
  int		idx, num, offset;
  char		code_str[3];
  Arg		args[10];

  if ( currentRecogIdx != -1 ){
    offset = currentCandPage * MAX_DISP_CANDIDATE;
    idx = (int)cli;
    if(offset + idx < MAX_CANDIDATE_CATEGORY){
      code = cands_code[currentRecogIdx][offset + idx];
      result_code[currentRecogIdx] = code;

      code_str[0] = (code>>8)|0x80;
      code_str[1] = (code&0xff)|0x80;
      code_str[2] = 0;
      num = 0;
      XtSetArg( args[num], XtNlabel, code_str ); num++;
      XtSetValues( result_widgets[currentRecogIdx], args, num );
    }
  }
  XtPopdown( candPopShell );

  currentRecogIdx = -1;
  currentCandPage = 0;
}

static void	prevCandProc( Widget w, XtPointer cli, XtPointer clo )
{
  int i, j, num, idx, offset;
  Arg		args[10];

  currentCandPage--;
  if(currentCandPage < 0) currentCandPage = 0;

  if(  MAX_CANDIDATE_CATEGORY / MAX_DISP_CANDIDATE> currentCandPage)
    i = MAX_DISP_CANDIDATE;
  else 
    i = MAX_CANDIDATE_CATEGORY % MAX_DISP_CANDIDATE;

  for( j = 0; j < MAX_DISP_CANDIDATE ; j++ ){
    num = 0;
    XtSetArg( args[num], XtNlabel, ""); num++;
    XtSetValues( candBtns[j], args, num );
  }

  idx = currentRecogIdx;
  offset = currentCandPage * MAX_DISP_CANDIDATE;
  for( j=0; j<MAX_DISP_CANDIDATE; j++, offset++ ){
    char	code_str[3];

    code_str[0] = (cands_code[idx][offset]>>8)|0x80;
    code_str[1] =  cands_code[idx][offset]    |0x80;
    code_str[2] = 0;
    num = 0;
    XtSetArg( args[num], XtNlabel, code_str ); num++;
    XtSetValues( candBtns[j], args, num );
  }

}

static void	nextCandProc( Widget w, XtPointer cli, XtPointer clo )
{
  int i, j, num, idx, offset;
  Arg		args[10];

  currentCandPage++;
  if(currentCandPage > MAX_CANDIDATE_CATEGORY / MAX_DISP_CANDIDATE - 1) 
    currentCandPage = MAX_CANDIDATE_CATEGORY / MAX_DISP_CANDIDATE - 1;

  if(  currentCandPage > MAX_CANDIDATE_CATEGORY / MAX_DISP_CANDIDATE )
    i = MAX_DISP_CANDIDATE;
  else 
    i = MAX_CANDIDATE_CATEGORY % MAX_DISP_CANDIDATE;

  for( j = 0; j < MAX_DISP_CANDIDATE ; j++ ){
    num = 0;
    XtSetArg( args[num], XtNlabel, ""); num++;
    XtSetValues( candBtns[j], args, num );
  }

  idx = currentRecogIdx;
  offset = currentCandPage * MAX_DISP_CANDIDATE;
  for( j=0; j<MAX_DISP_CANDIDATE; j++, offset++ ){
    char	code_str[3];

    code_str[0] = (cands_code[idx][offset]>>8)|0x80;
    code_str[1] =  cands_code[idx][offset]    |0x80;
    code_str[2] = 0;
    num = 0;
    XtSetArg( args[num], XtNlabel, code_str ); num++;
    XtSetValues( candBtns[j], args, num );
  }

}

void	NnmCreateCandidatePopup( Widget top )
{
  Arg		args[10];
  int		i, j, idx, num;

  candPopShell = XtCreatePopupShell( "candshell",
				     overrideShellWidgetClass,
				     //				     transientShellWidgetClass,
				     top, NULL, 0 );
  candForm = XtCreateManagedWidget( "candform", formWidgetClass,
				      candPopShell, NULL, 0 );

  num = 0;
  XtSetArg( args[num], XtNfromVert, NULL ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  XtSetArg( args[num], XtNborderWidth, 1 ); num++;
  XtSetArg( args[num], XtNinternational, True ); num++;
  XtSetArg( args[num], XtNlabel, "       " ); num++;

  for( idx=i=0; i<DISP_CAND_ROW; i++ ){
    for( j=0; j<DISP_CAND_COLUMN; j++ ){
      char	tmp[2048];

      sprintf( tmp, "%02d", idx );
      candBtns[idx] = XtCreateManagedWidget( tmp, commandWidgetClass,
					     candForm, args, num );
      XtAddCallback( candBtns[idx], XtNcallback, candBtnProc,
		     (XtPointer)idx );
      XtSetArg( args[0], XtNfromVert, candBtns[idx] );
      idx++;
    }
    XtSetArg( args[0], XtNfromVert, NULL );
    XtSetArg( args[1], XtNfromHoriz, candBtns[idx-1] );
  }

  num = 0;
  XtSetArg( args[num], XtNfromVert, candBtns[idx - 1] ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  prevCand = XtCreateManagedWidget( "prev", commandWidgetClass,
				     candForm, args, num);
  XtAddCallback( prevCand, XtNcallback, prevCandProc, (XtPointer)j );

  num = 0;
  XtSetArg( args[num], XtNfromVert, candBtns[idx - 1] ); num++;
  XtSetArg( args[num], XtNfromHoriz, prevCand ); num++;
  nextCand = XtCreateManagedWidget( "next", commandWidgetClass,
				     candForm, args,  num);
  XtAddCallback( nextCand, XtNcallback, nextCandProc,(XtPointer)j );
  num = 0;
  XtSetArg( args[num], XtNfromVert, candBtns[idx - 1] ); num++;
  XtSetArg( args[num], XtNfromHoriz, nextCand ); num++;
  clearCand = XtCreateManagedWidget( "clear", commandWidgetClass,
				     candForm, args,  num);
  XtAddCallback( clearCand, XtNcallback, clearCandProc,(XtPointer)j );
}

#ifdef WNN

static void	kouhoBtnProc( Widget w, XtPointer cli, XtPointer clo )
{
  int		i, idx;
  wchar         temp[256];

  if ( currentRecogIdx != -1 ){
    idx = (int)cli;
    currentKouho = (currentKouhoPage * MAX_DISP_KOUHO) + idx;
    if(currentKouho < zenkouhoSuu){
 
      NnmGetZenkouho(currentKouho, temp);
      for( i=0; i<MAX_DISP_RESULT; i++ ){
	NnmBtnChangeCode( i, 0 );
      }
      
      NumRecogChar = wchstrlen(temp);
      
      for( i=0; i<NumRecogChar; i++ ){
	if ( (temp[i]>>8)!=0 ){
	  result_code[i] = temp[i] & 0x7f7f;
	}else{
	  result_code[i] = temp[i] & 0xff;
	}
	NnmBtnChangeCode( i, result_code[i] );
      }
      result_code[i] = 0;
    }
  }
  XtPopdown( kouhoPopShell );

  currentKouhoPage = 0;
}

static void	prevKouhoProc( Widget w, XtPointer cli, XtPointer clo )
{
  int i, j, num, max;
  Arg		args[10];

  max = zenkouhoSuu / MAX_DISP_KOUHO;
  if((zenkouhoSuu % MAX_DISP_KOUHO) == 0) max--;

  currentKouhoPage--;
  if(currentKouhoPage < 0) currentKouhoPage = 0;

  if( max > currentKouhoPage)
    i = MAX_DISP_KOUHO;
  else 
    i = zenkouhoSuu % MAX_DISP_KOUHO;

  for( j = 0; j < MAX_DISP_KOUHO ; j++ ){
    num = 0;
    XtSetArg( args[num], XtNlabel, ""); num++;
    XtSetValues( kouhoBtns[j], args, num );
  }

  for( j = 0; j < i ; j++ ){
    char  code_str[256];
    wchar temp[256];
    bzero(temp, 256);
    
    NnmGetZenkouho((currentKouhoPage * MAX_DISP_KOUHO) + j, temp);
    wch2uch(temp, code_str);
    
    num = 0;
    XtSetArg( args[num], XtNlabel, code_str ); num++;
    XtSetValues( kouhoBtns[j], args, num );
  }

}

static void	nextKouhoProc( Widget w, XtPointer cli, XtPointer clo )
{
  int i, j, num, max;
  Arg		args[10];

  max = zenkouhoSuu / MAX_DISP_KOUHO;
  if((zenkouhoSuu % MAX_DISP_KOUHO) == 0) max--;

  currentKouhoPage++;
  if(currentKouhoPage > max) 
    currentKouhoPage = max;

  if(  zenkouhoSuu / MAX_DISP_KOUHO > currentKouhoPage)
    i = MAX_DISP_KOUHO;
  else 
    i = zenkouhoSuu % MAX_DISP_KOUHO;

  for( j = 0; j < MAX_DISP_KOUHO ; j++ ){
    num = 0;
    XtSetArg( args[num], XtNlabel, ""); num++;
    XtSetValues( kouhoBtns[j], args, num );
  }

  for( j = 0; j < i ; j++ ){
    char  code_str[256];
    wchar temp[256];
    bzero(temp, 256);
    
    NnmGetZenkouho((currentKouhoPage * MAX_DISP_KOUHO) + j, temp);
    wch2uch(temp, code_str);
    
    num = 0;
    XtSetArg( args[num], XtNlabel, code_str ); num++;
    XtSetValues( kouhoBtns[j], args, num );
  }
}

void	NnmCreateKouhoPopup( Widget top )
{
  Arg		args[10];
  int		i, num;

  kouhoPopShell = XtCreatePopupShell( "kouhoshell",
				     overrideShellWidgetClass,
				     //				     transientShellWidgetClass,
				     top, NULL, 0 );
  kouhoForm = XtCreateManagedWidget( "kouhoform", formWidgetClass,
				      kouhoPopShell, NULL, 0 );

  num = 0;
  XtSetArg( args[num], XtNfromVert, NULL ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  XtSetArg( args[num], XtNborderWidth, 1 ); num++;
  XtSetArg( args[num], XtNinternational, True ); num++;
  XtSetArg( args[num], XtNlabel, "       " ); num++;
  
  for( i=0; i<MAX_DISP_KOUHO; i++ ){
    char tmp[2048];

    sprintf( tmp, "%02d", i);
    kouhoBtns[i] = XtCreateManagedWidget( tmp, commandWidgetClass,
					   kouhoForm, args, num );
    XtAddCallback( kouhoBtns[i], XtNcallback, kouhoBtnProc,
		   (XtPointer)i );
    XtSetArg( args[0], XtNfromVert, kouhoBtns[i] );
  }

  num = 0;
  XtSetArg( args[num], XtNfromVert, kouhoBtns[MAX_DISP_KOUHO - 1] ); num++;
  XtSetArg( args[num], XtNfromHoriz, NULL ); num++;
  prevKouho = XtCreateManagedWidget( "prev", commandWidgetClass,
				     kouhoForm, args, num);
  XtAddCallback( prevKouho, XtNcallback, prevKouhoProc, NULL);
  num = 0;
  XtSetArg( args[num], XtNfromVert, kouhoBtns[MAX_DISP_KOUHO - 1] ); num++;
  XtSetArg( args[num], XtNfromHoriz, prevKouho ); num++;
  nextKouho = XtCreateManagedWidget( "next", commandWidgetClass,
				     kouhoForm, args,  num);
  XtAddCallback( nextKouho, XtNcallback, nextKouhoProc, NULL);

}

void RevConv()
{
  int i, j;
  wchar yomi[256];
  
  if(!IsConv) return;

  NnmCandPopdown();
  IsConv = 0;
  
  NnmGetYomi(yomi);
  NumRecogChar = wchstrlen(yomi);
  
  for( i=j=0; i<NumRecogChar; i++ ){
    if ( (yomi[i]>>8)!=0 ){
      result_code[i] = yomi[i] & 0x7f7f;
    }else{
      result_code[i] = yomi[i] & 0xff;
    }
    NnmBtnChangeCode( i, result_code[i] );
  }
  result_code[i] = 0;
}
#endif /* WNN */
