/* 
   $Id: nnmUI.h,v 1.9 2002/02/28 08:24:37 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifndef NNM_UI_H
#define NNM_UI_H

#include "NnmProto.h"

// nnmime.c
void NnmGetResource(Widget w, String name, XtArgVal *value_return);

// nnmWindow.c
int	NnmIsFocus(void);
void	NnmPopup();
void	NnmAutoPopup();
void	NnmPopdown( void );
Boolean	NnmForcePopdown( Widget w, XtPointer clo, XEvent *ev, Boolean *ctd );
void	NnmCreatePopShell( Widget top );
void    NnmGetShellPos(int *x, int *y, int *w, int *h);
void    NnmGetResultFormPos(int *x, int *y, int *w, int *h);



// nnmCommand.c
void    InitSendEventKey( Display *dpy);
void	SendEventKey( Display *dpy, unsigned int keysym,
  unsigned int state, int pressed);
Widget	CreateCommandWidgets( char *name, Widget parent, Arg args[], int num );
Widget	CreateKBDWidgets( char *name, Widget parent, Arg cargs[], int num );
Widget	CreateKigouWidgets( char *name, Widget parent,Arg cargs[], int num );

void	NnmCreateJISPopup( Widget top );
void	NnmCreateKouhoPopup( Widget top );

void  MapTopForm(void);
void  MapKBDForm(void);
void  MapKigouForm(void);
void  UnmapTopForm(void);
void  UnmapKBDForm(void);
void  UnmapKigouForm(void);

// nnmCanvas.c
void	NnmCreateCanvases( Widget parent );
int     NnmCanvasClear(int idx);
int	NnmCurrentCanvasClear(void);
int	NnmCurrentCanvasRecognize( int NextCanvas, int block );
void    NnmHandleRecognizeResult(void);
void    NnmRemoveTimeOut(void);

// nnmRecogField.c
void	NnmAppendResult( unsigned long code, NnmRawCharInfoRec *charInfo,
			 ulong cands[], NnmFeatureRec *fv);
void	NnmResultInsertChar( unsigned long code );
void	NnmResultAllClear(void);
void	NnmResultBackSpace( void );
void	NnmResultESCKey( void );
void	NnmResultCRKey( void );
void	NnmCommitResult( void );
void	NnmCandPopdown( void );
void	NnmCreateResultWidgets( Widget parent );
void	NnmCreateCandidatePopup( Widget top );
void    NnmInitRecognizeField(void);
void    NnmGetWindowPos(Widget w, int *x, int *y, int *width, int *height);

#ifdef WNN
void	NnmTransResult( void );
void    RevConv( void );
#endif /* WNN */


#ifdef WNN

#include <wnn/jlib.h>
#include <wnn/jllib.h>

// nnmWnn.c

int     wchstrlen(wchar *str);
void    wch2uch(wchar *wch, unsigned char *uch);

int     NnmOpenJserver( Widget w );
void    NnmGetYomi(wchar *yomi);
int     NnmZenkouhoSuu(void);
void    NnmGetZenkouho(int kouho, wchar *kanji);
int     NnmTanHenkan(wchar *yomi, wchar *kanji);

#endif /* WNN */

#endif
